@if exp="typeof(global.world_object) == 'undefined'"
@iscript

KAGLoadScript('YAML.tjs');

/**
 * [hg
 * tbNꗗ
 * O[oɈȉ̃\bhꍇ̓tbNƂČĂяo܂
 * setTimeHook(time, elm)     ԕύXtbN
 * setStageHook(stage, elm)   Xe[WύXtbN
 */
var setTimeHook;
var setStageHook;

/**
 * ̎
 */
var EMPTY = %[];

/**
 * ̓e\
 * @param name 
 * @param dict IuWFNg
 */
function showKeys(name, dict) {
    name += ":";
    if (dict) {
        var array = [];
        array.assign(dict);
        for (var i=0; i<array.count; i+= 2) {
            if (i != 0) {
                name += ",";
            }
            name += (array[i] + ":" + array[i+1]);
        }
        dm(name);
    }
}

/*
 * p[^̑O擾
 * @param value p[^
 */
function getTo(value)
{
    var p;
    if ((p = value.indexOf(":")) > 0) {
        return value.substring(0, p);
    } else  if (p == 0) {
        return void;
    } else  {
        return value;
    }
}

/*
 * p[^̌㑤擾
 * @param value p[^
 */
function getFrom(value) {
    var p;
    if ((p = value.indexOf(":")) >= 0) {
        return value.substring(p+1);
    } else {
        return void;
    }
}

function toNumber(value)
{
    if (value === void || value === null) {
        return value;
    } else {
        return +value;
    }
}

var transitionName = %[
    "universal" => true,
    "crossfade" => true,
    "scroll" => true,
    "wave" => true,
    "mosaic" => true,
    "turn" => true,
    "rotatezoom" => true,
    "rotatevanish" => true,
    "rotateswap" => true,
    "ripple" => true,
    ];

var transitionParam = %[
    "time" => true,
    "rule" => true,
    "vague" => true,
    "from" => true,
    "stay" => true,
    "wavetype" => true,
    "maxh" => true,
    "maxomega" => true,
    "bgcolor1" => true,
    "bgcolor2" => true,
    "mosaic" => true,
    "maxsize" => true,
    "turn" => true,
    "bgcolor" => true,
    "factor" => true,
    "accel" => true,
    "twistaccel" => true,
    "twist" => true,
    "centerx" => true,
    "centery" => true,
    "rwidth" => true,
    "roundness" => true,
    "speed" => true,
    "maxdrift" => true,
    "msgoff" => true,
    "charoff" => true,
    "transwait" => true,
    ];

var actionParam = %[
    "time" => true,
    "delay" => true,
    "x" => true,
    "y" => true,
    "toptime" => true,
    "vibration" => true,
    "waittime" => true,
    "cycle" => true,
    "distance" => true,
    "falltime" => true,
    "zoom" => true,
    "angvel" => true,
    "angle" => true,
    "showtime" => true,
    "hidetime" => true,
    "intime" => true,
    "outtime" => true,
    "opacity" => true,
    ];

/**
 * 摜̊NX
 */
class KAGEnvImage {

    var _ret;
    property ret {
        getter() {
            return _ret;
        }
        setter(v) {
            if (v === void) {
                _ret = 0;
            } else {
                if (v < ret) {
                    _ret = v;
                }
            }
        }
    }

    // XLbvԂ
    function isSkip() {
        return env.kag.skipMode || env.kag.noeffect;
    }

    // eێ
    var env;

    /// \
    // BOTH      oXgAbv{tFCX (Wj
    // BU        oXgAbv
    // FACE      tFCX
    // CLEAR               (W)
    // INVISIBLE \
    var _disp;

    // oXgAbv\
    function isShowBU() {
        return _disp <= BU;
    }

    function isShowFace() {
        return _disp == BOTH || _disp == FACE;
    }

    property disp {
        getter() {
            return _disp;
        }
        setter(v) {
            if (v !== void) {
                if (v < CLEAR && (_disp >= CLEAR)) {
                    if (opacity === void) {
                        // \Ԃ\ɐ؂ւƂ͕sx𐧌
                        opacity = 255;
                    }
                }
                _disp = v;
                redraw = true;
            }
        }
    }

    /// ĕ`wtO
    var redraw;

    // 
    var resetFlag;
    // tF[htO
    var fadeTime;

    
    // 
    var _type;
    var doType;
    property type {
        getter() {
            return _type;
        }
        setter(v) {
            _type = v;
            doType = (v !== void);
        }
    }

    // x
    var opacityFrom;
    var opacityTime;
    var _opacity;
    var doOpacity;
    property opacity {
        getter() {
            return _opacity;
        }
        setter(v) {
            _opacity = v;
            doOpacity = (v !== void);
        }
    }

    // ]
    var rotateFrom;
    var rotateTime;
    var _rotate;
    var doRotate;
    property rotate {
        getter() {
            return _rotate;
        }
        setter(v) {
            _rotate = v;
            doRotate = (v !== void);
        }
    }

    // Y[
    var zoomFrom;
    var zoomTime;
    var _zoom;
    var doZoom;
    property zoom {
        getter() {
            return _zoom;
        }
        setter(v) {
            _zoom = v;
            doZoom = (v !== void);
        }
    }

    // ]_w
    var _afx;
    var _afy;
    var doAffine;
    property afx {
        getter() {
            return _afx;
        }
        setter(v) {
            _afx = v;
            doAffine = (v !== void);
        }
    }
    property afy {
        getter() {
            return _afy;
        }
        setter(v) {
            _afy = v;
            doAffine = (v !== void);
        }
    }

    // \ʒuW
    var xpos;
    var ypos;
    var xposFrom;
    var yposFrom;
    var moveTime;
    var moveAccel;

    // ʒuύX
    var reposition;
    
    // ANV
    var doStopAction;
    var actionList;
    var currentActionList;
    var syncMode;

    // 摜␮w
    var _grayscale;
    property grayscale {
        getter() {
            if (env.colorall) {
                return env.grayscale;
            } else {
                return _grayscale;
            }
        }
        setter(v) {
            _grayscale = v;
            if (!env.colorall) {
                redraw = true;
            }
        }
    }

    var _rgamma;
    property rgamma {
        getter() {
            if (env.colorall) {
                return env.rgamma;
            } else {
                return _rgamma;
            }
        }
        setter(v) {
            _rgamma = v;
            if (!env.colorall) {
                redraw = true;
            }
        }
    }

    var _ggamma;
    property ggamma {
        getter() {
            if (env.colorall) {
                return env.ggamma;
            } else {
                return _ggamma;
            }
        }
        setter(v) {
            _ggamma = v;
            if (!env.colorall) {
                redraw = true;
            }
        }
    }
    
    var _bgamma;
    property bgamma {
        getter() {
            if (env.colorall) {
                return env.bgamma;
            } else {
                return _bgamma;
            }
        }
        setter(v) {
            _bgamma = v;
            if (!env.colorall) {
                redraw = true;
            }
        }
    }

    function resetColor(param, elm) {
        _grayscale = void;
        _rgamma = void;
        _ggamma = void;
        _bgamma = void;
        if (!env.colorall) {
            redraw = true;
        }
    }
    
    // ʍXVݒ
    var trans;
    
    // tF[hw̃ftHgl
    property fadeValue {
        getter() {
            return env.fadeValue;
        }
    }
    
    /**
     * RXgN^
     * @param env 
     */
    function KAGEnvImage(env) {
        this.env = env;
        actionList = new Array();
        currentActionList = new Array();
        _disp = CLEAR;
    }

    function initImage() {
        type = void;
        opacityFrom = void;
        opacityTime = void;
        opacity = void;
        rotateFrom = void;
        rotateTime = void;
        rotate = void;
        zoomFrom = void;
        zoomTime = void;
        zoom = void;
        afx = void;
        afy = void;
        xpos     = void;
        ypos     = void;
        xposFrom = void;
        yposFrom = void;
        moveTime = void;
        moveAccel = void;
        reposition = false;

        rgamma = void;
        ggamma = void;
        bgamma = void;
        grayscale = void;
        
        resetFlag = false;
        fadeTime = void;
        actionList.clear();
        currentActionList.clear();
        _disp = CLEAR;
    }

    function initLayer(layer) {
        layer.reset();
        if (!doType) {
            _type    = void;
        }
        if (!doOpacity) {
            _opacity = void;
        }
        if (!doRotate) {
            _rotate = void;
        }
        if (!doZoom) {
            _zoom = void;
        }
        if (!doAffine) {
            _afx = void;
            _afy = void;
        }
        clearAction();
    }
    
    function finalize() {
        clearAction();
        invalidate actionList;
        invalidate currentActionList;
    }

    function setXPos(cmd, elm) {
        if (xpos !== void && moveTime === void) {
            moveTime  = elm.time;
            moveAccel = elm.accel;
        }
        xposFrom = getFrom(cmd);
        xpos     = getTo(cmd);
        //dm("Xʒuw:", xpos, xposFrom, moveTime);
        reposition = true;
    } 

    function setYPos(cmd, elm) {
        if (ypos !== void && moveTime === void) {
            moveTime  = elm.time;
            moveAccel = elm.accel;
        }
        yposFrom = getFrom(cmd);
        ypos     = getTo(cmd);
        //dm("Yʒuw:", ypos, yposFrom, moveTime);
        reposition = true;
    }

    /**
     * ANV̒ǉ
     */
    function addAction(action) {
        // K̃W[͔r
        if (action.module == "LayerFadeToModeModule") {
            opacity     = action.opacity;
            opacityTime = action.time;
        } else if (action.module == "LayerToRotateModule") {
            rotate = action.angle;
            rotateTime = action.time;
        } else if (action.module == "LayerNormalZoomModule") {
            zoom = action.zoom;
            zoomTime = action.time;
        } else if (action.module == "LayerAccelMoveModule") {
            xpos = action.x;
            ypos = action.y;
            moveTime = action.time;
            moveAccel = 1;
            reposition = true;
        } else if (action.module == "LayerNormalMoveModule") {
            xpos = action.x;
            ypos = action.y;
            moveTime = action.time;
            moveAccel = 0;
            reposition = true;
        } else if (action.module == "LayerDecelMoveModule") {
            xpos = action.x;
            ypos = action.y;
            moveTime = action.time;
            moveAccel = -1;
            reposition = true;
        } else {
            actionList.add(action);
        }
    }

    /**
     * ANV̏
     */
    function clearAction() {
        currentActionList.clear();
    }
    
    /**
     * ANVݒ
     * @param name ANV
     * @param elm p[^
     */
    function setAction(name, elm) {
        if (env.actions !== void) {
            var info;
            if ((info = env.actions[name]) !== void) {
                if (info instanceof "Dictionary") {
                    var action = %[];
                    (Dictionary.assign incontextof action)(info, false); 
                    foreach(elm, function(name, value, elm, action) {
                        if (actionParam[name] !== void) {
                            action[name] = value;
                        }
                    }, action);
                    addAction(action);
                    return true;
                } else if (info instanceof "Array") {
                    for (var i=0;i<info.count;i++) {
                        var action = %[];
                        (Dictionary.assign incontextof action)(info[i], false); 
                        foreach(elm, function(name, value, elm, action) {
                            if (actionParam[name] !== void) {
                                action[name] = value;
                            }
                        }, action);
                        addAction(action);
                    }
                    return true;
                }
                return false;
            }
            if (elm !== void && name.substring(0,5) == "Layer") {
                var moduleType;
                try {
                    moduleType = global[name];
                    if (moduleType !== void && typeof moduleType == "Object" && moduleType.LayerModule != void) {
                        // ANVW[̏ꍇ
                        var action = %[];
                        foreach(elm, function(name, value, elm, action) {
                            if (actionParam[name] !== void) {
                                action[name] = value;
                            }
                        }, action);
                        action.module = name;
                        action.time = elm.time if elm.time !== void;
                        if (action.time !== void) {
                            action.time *= kag.drawspeed;
                        }
                        addAction(action);
                        return true;
                    }
                } catch() {
                    // 
                }
            }
        }
        return false;
    }

    /**
     * ANV
     */
    function stopAction() {
        clearAction();
        doStopAction = true;
    }
    
    /**
     * gWV̎擾
     */
    function getTrans(name, elm) {
        var tr = %[];
        // Owŏ㏑
        var info;
        if (env.transitions !== void && (info = env.transitions[name]) !== void) {
            // Rs[
            (Dictionary.assign incontextof tr)(info, false); 
            // p[^̃Rs[
            foreach(elm, function(name, value, elm, tr) {
                if (transitionParam[name] !== void) {
                    //dm("p[^Rs[:" + name + ":" + value);
                    tr[name] = value;
                }
            }, tr);
        } else if (elm != null && (transitionName[name] !== void || name.substring(0,5) == "trans")) {
            // K̃gWV
            // p[^̃Rs[
            foreach(elm, function(name, value, elm, tr) {
                if (transitionParam[name] !== void) {
                    tr[name] = value;
                }
            }, tr);
            tr.method = name;
        }
        return tr;
    }

    /**
     * tF[h̐ݒ
     */
    function setFade(param, elm) {
        if (param !== void) {
            fadeTime = isSkip() || env.transMode ? 0 : param;
        }
    }

    function setFade2(param, elm) {
        // true r
        if (param > 1) {
            setFade(param, elm);
        }
    }
    
    /**
     * gWVݒ
     * @param name gWV
     */
    function _setTrans(name, elm) {
        //dm("gWVݒ:" + name);
        var tr = getTrans(name, elm);
        if (tr.method !== void) {
            if (!env.transMode && !isSkip()) {
                trans = tr;
            } else {
                // ȃgWVw
                trans = %[];
            }
            redraw = true;
            return true;
        }
        return false;
    }

    function setTrans(name, elm) {
        if (name == "void") {
            trans = %[];
        } else {
            _setTrans(name, elm);
        }
    }
    
    /**
     * gWVݒ
     * @param param gWVw@܂͎
     * @return ݒ肵ꍇ
     */
    function setTrans2(param) {
        if (trans === void) {
            //dm("gWVݒ2:" + param);
            if (param === void) {
                return false;
            } else if (typeof param == "String") {
                _setTrans(param);
                return true;
            } else if (param instanceof "Dictionary") {
                _setTrans(param.method, param);
                return true;
            }
            return false;
        } else {
            return true;
        }
    }
    
    /**
     * ԍXV
     */
    function updateLayer(layer) {
        if (resetFlag) {
            layer.visible = isShowBU();
            layer.reset();
            _type    = void;
            _opacity = void;
            _rotate = void;
            _zoom = void;
            _afx = void;
            _afy = void;
            clearAction();
            _rgamma = void;
            _ggamma = void;
            _bgamma = void;
            _grayscale = void;
            resetFlag = false;
            fadeTime = void;
        } else {
            if (redraw) {
                if (isShowBU()) {
                    if (fadeTime !== void && fadeTime > 0) {
                        opacityFrom = 0;
                        opacity     = 255 if opacity === void;
                        opacityTime = fadeTime > 1 ? fadeTime : fadeValue;
                    }
                    layer.visible = true;
                } else if (disp == FACE) {
                    layer.visible = false;
                } else {
                    // 
                    if (fadeTime !== void && fadeTime > 0) {
                        opacityFrom = void;
                        opacity     = 0;
                        opacityTime = fadeTime > 1 ? fadeTime : fadeValue;
                    }
                    if (!doOpacity) {
                        layer.visible = false;
                    }
                }
            }
            fadeTime = void;

            if (doAffine) {
                layer.afx = afx;
                layer.afy = afy;
                doAffine = false;
            }
            if (doOpacity) {
                //dm("xύX:" + opacity + ":" + opacityTime); 
                if (opacityFrom !== void) {
                    layer.opacity = opacityFrom;
                    opacityFrom = void;
                }
                layer.setOpacityTime(opacity, opacityTime);
                doOpacity = false;
            }
            if (doRotate) {
                //dm("]ύX:" + rotate + ":" + rotateTime);
                if (rotateFrom !== void) {
                    layer.rotate = rotateFrom;
                    rotateFrom = void;
                }
                layer.setRotateTime(rotate, rotateTime);
                doRotate = false;
            }
            if (doZoom) {
                //dm("Y[ύX:" + zoom + ":" + zoomTime);
                if (zoomFrom !== void) {
                    layer.zoom = zoomFrom;
                    zoomFrom = void;
                }
                layer.setZoomTime(zoom, zoomTime);
                doZoom = false;
            }
            if (doType) {
                //dm("ʕύX");
                layer.type = type;
                doType = false;
            }

            if (doStopAction) {
                layer.stopAction();
                doStopAction = false;
            }
            // ANV
            if (actionList.count > 0) {
                for (var i=0;i<actionList.count;i++) {
                    var action = actionList[i];
                    layer.beginAction(action);
                    if (action.time == void || action.time == 0) {
                        currentActionList.add(action);
                    }
                }
                actionList.clear();
            }
        }
        if (syncMode) {
            ret = kag._waitLayerAction(layer);
            //dm("ANV҂:" + ret);
            syncMode = false;
        }
    }

    var commands = %[
    tagname : null, 
    time : null,
    type : function(param, elm) {
        type =  global[param];
    } incontextof this,
    opacity : function(param, elm) {
        opacityFrom = toNumber(getFrom(param));
        opacity     = toNumber(getTo(param));
        opacityTime = isSkip() ? 0 : elm.time;
    } incontextof this,
    fade :  setFade incontextof this,
    rotate : function(param, elm) {
        rotateFrom = toNumber(getFrom(param));
        rotate     = toNumber(getTo(param));
        rotateTime = isSkip() ? 0 : elm.time;
    } incontextof this,
    zoom : function(param, elm) {
        zoomFrom = toNumber(getFrom(param));
        zoom     = toNumber(getTo(param));
        zoomTime = isSkip() ? 0 : elm.time;
    } incontextof this,
    afx : function(param, elm) {
        afx = param;
    } incontextof this,
    afy : function(param, elm) {
        afy = param;
    } incontextof this,
    reset : function(param, elm) {
        resetFlag = true;
    } incontextof this,
    grayscale : function(param, elm) {
        grayscale = param;
    } incontextof this,
    rgamma : function(param, elm) {
        rgamma = param;
    } incontextof this,
    ggamma : function(param, elm) {
        ggamma = param;
    } incontextof this,
    bgamma : function(param, elm) {
        bgamma = param;
    } incontextof this,
    resetcolor : this.resetColor incontextof this,
    trans  : setTrans incontextof this,
    action : setAction incontextof this,
    stopaction : stopAction incontextof this,

    sync : function(param) { if (param) { syncMode = true; } } incontextof this,

    show : function(param) { disp = BOTH;   } incontextof this,
    hide : function(param) { disp = CLEAR; } incontextof this,
    visible : function(param) { disp = param ? BOTH : CLEAR; }  incontextof this,
    xpos : this.setXPos incontextof this,
    ypos : this.setYPos incontextof this,
    accel : null, // 
        ];

    /**
     * R}h̎s
     * @param cmd R}h
     * @param param p[^
     * @param elm ̃R}h܂ޑSp[^
     * @return ssꂽꍇ true
     */
    function doCommand(cmd, param, elm) {
        //dm("R}h:" + cmd + " p[^:" + param);
        var func;
        if ((func = commands[cmd]) !== void) {
            if (func != null) {
                func(param, elm);
            }
            return true;
        }
        // ōlقH
        if (actionParam[cmd] !== void) {
            return true;
        }
        if (transitionParam[cmd] !== void) {
            return true;
        }
        return false;
    }

    /**
     * Z[u
     */
    function onStore(f) {
        f.type    = type;
        f.opacity = opacity;
        f.rotate  = rotate;
        f.zoom    = zoom;
        f.xpos    = xpos;
        f.ypos    = ypos;
        f.disp    = disp;
        f.actionList = [];
        (Array.assign incontextof f.actionList)(currentActionList);
        //for (var i=0;i<currentActionList.count;i++) {
        //    dm("ANVۑ:" + currentActionList[i].module);
        //}

        f.grayscale = _grayscale;
        f.rgamma    = _rgamma;
        f.ggamma    = _ggamma;
        f.bgamma    = _bgamma;
    }

    /**
     * [h
     */
    function onRestore(f) {

        type = f.type;
        opacity     = f.opacity;
        opacityFrom = void;
        opacityTime = void;
        rotate      = f.rotate;
        rotateFrom  = void;
        rotateTime  = void;
        zoom        = f.zoom;
        zoomFrom    = void;
        zoomTime    = void;
        if (f.actionList !== void) {
            for (var i=0;i<f.actionList.count;i++) {
                addAction(f.actionList[i]);
                //dm("ANVA:" + f.actionList[i].module);
            }
        }
        xpos      = f.xpos;
        xposFrom  = void;
        ypos      = f.ypos;
        yposFrom  = void;
        moveTime  = void;
        moveAccel = void;
        reposition = true;

        _grayscale = f.grayscale;
        _rgamma    = f.rgamma;
        _ggamma    = f.ggamma;
        _bgamma    = f.bgamma;
        if (_grayscale != void ||
            _rgamma    != void ||
            _ggamma    != void ||
            _bgamma    != void) {
            redraw = true;
        }
        
        disp = f.disp;
    }

    // ̃\bh
    // function getLayer(base);
    // function drawLayer(layer);

    /**
     * Czu(W)F㌴_
     * @param layer ΏۃC
     */
    function calcPosition(layer) {
        if (reposition) {
            //dm("ʒuw1",xpos,ypos);
            var l = (int)xpos;
            var t = (int)ypos;
            if (moveTime !== void && moveTime > 0) {
                if (xposFrom !== void || yposFrom !== void) {
                    var fl = xposFrom !== void ? (int)xposFrom : l;
                    var ft = yposFrom !== void ? (int)yposFrom : t;
                    layer.setPos(fl, ft);
                }
                layer.setMove(l, t, moveAccel, moveTime);
            } else {
                layer.setMove(l, t);
            }
            xposFrom = void;
            yposFrom = void;
            moveTime = void;
            reposition = false;
        }
    }

    // gWVs
    function beginTransition(trans) {
        if (trans.time === void || isSkip()) {
            trans.time = 0;
        }
        trans.children = true;
        // 荞܂
        trans.tagname = "trans";
        kag.conductor.pendings.insert(0, %[ tagname : "syncmsg" ]);
        if (trans.transwait !== void) {
            kag.conductor.pendings.insert(0, %[ tagname : "wait", time : (int)trans.time + (int)trans.transwait, trans:true ]);
        } else {
            kag.conductor.pendings.insert(0, %[ tagname : "wt" ]);
        }
        kag.conductor.pendings.insert(0, trans);
    }

    /**
     * bZ[W
     */
    function hideMessage() {
        if (trans !== void && trans.msgoff) {
            kag.conductor.pendings.insert(0, %[ tagname : "er", all:true]);
            if (kag.setCurrentMessageLayerVisible(false)) {
                ret = -2;
            }
        }
    }
    
    /**
     * 摜̕`
     */
    function updateImage(base) {
        kag.updateBeforeCh = 1;
        // `XVKvȏꍇ
        if (redraw) {
            
            if (base === void && trans !== void) {

                fadeTime = void;

                if (trans.method !== void) {
                    kag.fore.base.stopTransition();
                    // SCobNAbv
                    kag.backupLayer(EMPTY, true);
                    // CΏ
                    var layer = getLayer(kag.back);
                    if (isShowBU()) {
                        drawLayer(layer);
                        calcPosition(layer);
                    }
                    updateLayer(layer);
                    beginTransition(trans);
                } else {
                    var layer = getLayer(base);
                    if (isShowBU()) {
                        drawLayer(layer);
                        calcPosition(layer);
                    }
                    updateLayer(layer);
                }
                    
            } else {

                // \ɕ`
                var layer = getLayer(base);

                // tF[h
                // ɕ\ĂƂ\݂̂̏ꍇ̓gWVőp
                if (fadeTime !== void && fadeTime > 0 && ((isShowBU() && layer.visible && layer.opacity > 0) || _disp == FACE)) {

                    kag.fore.base.stopTransition();
                    var trans = %[ "method" => "crossfade",
                                   "children" => true,
                                   "time" => fadeTime > 1 ? fadeTime : fadeValue];
                    fadeTime = void;

                    // SC𗠂ɃobNAbv
                    kag.backupLayer(EMPTY, true);
                    
                    // CΏ
                    layer = getLayer(kag.back);
                    if (isShowBU()) {
                        drawLayer(layer);
	                    calcPosition(layer);
                    }
                    updateLayer(layer);
                    beginTransition(trans);

                } else {
                    // tF[h
                    //dm("tF[h opacity Ŏ");
                    if (isShowBU()) {
                        drawLayer(layer);
	                    calcPosition(layer);
                    }
                    updateLayer(layer);
                }
            }

            redraw = false;
        } else {
            var layer = getLayer(base);
            calcPosition(layer);
            updateLayer(layer);
        }
        trans = void;
    }
}

/**
 * CnNX
 */
class KAGEnvLayer extends KAGEnvImage {

    // kag ̎Q
    property kag {
        getter() {
            return env.kag;
        }
    }

    /// `撆摜
    var imageFile;

    function KAGEnvLayer(env) {
        super.KAGEnvImage(env);
        redraw = false;
    }

    function onStore(f) {
        super.onStore(f);
        f.imageFile = imageFile;
    }
    
    function onRestore(f) {
        imageFile = f.imageFile;
        super.onRestore(f);
    }

    function setImageFile(file, elm) {

        imageFile = file;
        disp = BOTH;

        // wiw莞ɍWw肪ȂΏꏊ
        if (elm.xpos === void) {
            xpos = void;
        }
        if (elm.ypos === void) {
            ypos = void;
        }
        reposition = true;

        // L^
        kag.sflags["cg_" + (file.toUpperCase())] = true;

        return true;
    }

    var _layerCommands = %[
    file : function(param, elm) {
        setImageFile(param, elm);
    } incontextof this,
        ];

    /**
     * R}h̎s
     * @param cmd R}h
     * @param param p[^
     * @param elm ̃R}h܂ޑSp[^
     * @return ssꂽꍇ true
     */
    function doCommand(cmd, param, elm) {

        // ʃR}h
        if (super.doCommand(cmd, param, elm)) {
            return true;
        }
        // CʃR}h
        var func;
        if ((func = _layerCommands[cmd]) !== void) {
            if (func != null) {
                func(param, elm);
            }
            return true;
        }
        // CgR}hp
        if ((func = layerCommands[cmd]) !== void) {
            if (func != null) {
                func(param, elm);
            }
            return true;
        }

        var find = false;
        
        // ANV
        if (!find) {
            find = setAction(cmd, elm);
        }

        // XV
        if (!find) {
            find = _setTrans(cmd, elm);
        }

        // 摜̃[h
        if (!find) {
            find = setImageFile(cmd, elm);
        }
        return find;
    }

    // ̃\bh
    // function getLayer(base);
    // 
    function drawLayer(layer) {
        initLayer(layer);
        if (imageFile !== void) {
            try {
                layer.loadImages(%[ "storage" => imageFile]);
            } catch (e) {
                dm("摜̓ǂݍ݂Ɏs܂:" + imageFile);
            }
        }
        if (grayscale) {
            layer.doGrayScale();
        }
        if (rgamma != void || ggamma != void || bgamma != void) {
            layer.adjustGamma(rgamma == void ? 1.0 : rgamma, 0, 255,
                              ggamma == void ? 1.0 : ggamma, 0, 255,
                              bgamma == void ? 1.0 : bgamma, 0, 255);
        }
    }

    /**
     * KAG ^O
     * @param elm 
     */
    function tagfunc(elm) {
        //dm("C^O΂ꂽ");
        ret = void;
        foreach(elm, doCommand);
        hideMessage();
        updateImage();
        return ret;
    }
}

/**
 * x[XɂȂĂ郌C
 * event C̎QƂɗp
 */
class KAGEnvBaseLayer extends KAGEnvLayer {

    var name;

    /**
     * ԗpŏ
     */
    function setRedraw() {
        // \̏ꍇ͍ĕ`揈
        var layer = kag.fore[name];
        if (layer.visible) {
            redraw = true;
        }
    }
    
    /**
     * RXgN^
     * @param env 
     * @param name ̃C
     */
    function KAGEnvBaseLayer(env, name) {
        super.KAGEnvLayer(env);
        this.name = name;
    }

    function setImageFile(file, elm) {

        var eventTrans;
        
        if (file !== void) {

            var eventInfo;
            if (env.events !== void) {
                eventInfo = env.events[file];
            }
            if (eventInfo !== void) {
                eventTrans = eventInfo.trans;
                imageFile = eventInfo.image !== void ? eventInfo.image : v;
                xpos = elm.xpos !== void ? (int)elm.xpos : eventInfo.xoff;
                ypos = elm.ypos !== void ? (int)elm.ypos : eventInfo.yoff;
                reposition = true;
            } else {
                imageFile = file;
                xpos = elm.xpos !== void ? (int)elm.xpos : void;
                ypos = elm.ypos !== void ? (int)elm.ypos : void;
                reposition = true;
            }

            disp = BOTH;
            reposition = true;
            
            // L^
            kag.sflags["cg_" + (file.toUpperCase())] = true;
            
            // gWVw
            if (!setTrans2(eventTrans)) {
                if (!setTrans2(env.envinfo.eventTrans)) {
                    setTrans2(env.envinfo.envTrans);
                }
            }

        } else {
            imageFile = void;
            disp = CLEAR;
            xpos = elm.xpos !== void ? (int)elm.xpos : void;
            ypos = elm.ypos !== void ? (int)elm.ypos : void;
            reposition = true;
        }

        return true;
    }

    function getLayer(base) {
        if (base === void) {
            base = env.transMode ? kag.back : kag.fore;
        }
        return base[name];
    }

    var layerCommands = %[];
}

/**
 * KAG OiC̃xp
 */
class KAGEnvLevelLayer {

    // pC
    var layerId;
    /// \x
    var level;
    /// \΃x
    var absolute;

    /// ʒuύX
    var front;
    var back;

    /**
     * ԗpŏ
     */
    function setRedraw() {
        // \̏ꍇ͍ĕ`揈
        var layer = kag.fore.layers[env.initLayerCount + layerId];
        if (layer.visible) {
            redraw = true;
        }
    }
    
    /**
     * RXgN^
     * @param layerId OiCID
     */
    function KAGEnvLevelLayer(layerId) {
        this.layerId = layerId;
        level = void;
    }

    function finalize() {
        // gĂC
        var id = env.initLayerCount + layerId;
        if (id < kag.fore.layers.count) {
            kag.fore.layers[id].clearImage();
            kag.back.layers[id].clearImage();
        }
    }

    /**
     * C̎擾
     * @param base fore / back      
     * Ƀxɉ front/back ̏s
     */
    function getLayer(base) {
        if (base === void) {
            base = env.transMode ? kag.back : kag.fore;
        }
        if (level === void) {
            level = env.defaultLevel;
        }
        var id = env.initLayerCount + layerId;
        kag.toLevel(id, level, base);
        if (front) {
            kag.toFront(id, base);
        } else if (back) {
            kag.toBack(id, base);
        }
        front = back = void;
        absolute = base.layers[id].absolute;
        return base.layers[id];
    }

    /**
     * xőO
     */
    function setFront() {
        front = true;
    }

    /**
     * xŌ
     */
    function setBack() {
        back = true;
    }

    /**
     * x̎w
     */
    function setLevel(cmd, elm) {
        level = cmd;
        absolute = void;
    } 

    function onStore(f) {
        f.layerId = layerId;
        f.level = level;
        f.absolute = absolute;
    }

    function onRestore(f) {
        layerId = f.layerId;
        level = f.level;
        absolute = f.absolute;

        // x̕A
        var layer = kag.fore.layers[env.initLayerCount + layerId];
        if (layer !== void) {
            if (level !== void) {
                layer.level = level;
            }
            if (absolute !== void) {
                layer.absolute = absolute;
            }
        }
    }
}

/**
 * PƃC
 */
class KAGEnvSimpleLayer extends KAGEnvLevelLayer, KAGEnvLayer {

    // O
    var name;
    
    /**
     * RXgN^
     * @param env
     * @param layerId
     * @param name
     * @param level
     */
    function KAGEnvSimpleLayer(env, layerId, name) {
        global.KAGEnvLayer.KAGEnvLayer(env);
        global.KAGEnvLevelLayer.KAGEnvLevelLayer(layerId);
        this.name = name;
    }

    function finalize() {
        // ԕύXs
        global.KAGEnvLevelLayer.finalize();
        global.KAGEnvLayer.finalize();
    }
    
    /**
     * Czu(Cp)F_
     * @param layer ΏۃC
     */
    function calcPosition(layer) {
        if (reposition) {
            //dm("ʒuw2");
            var l = kag.scWidth / 2 + (int)xpos - layer.imageWidth / 2;
            var t = kag.scHeight/ 2 + (int)ypos - layer.imageHeight / 2;
            if (moveTime !== void && moveTime > 0) {
                if (xposFrom !== void || yposFrom !== void) {
                    var fl = xposFrom !== void ? kag.scWidth  / 2 + (int)xposFrom - layer.imageWidth / 2 : l;
                    var ft = yposFrom !== void ? kag.scHeight / 2 + (int)yposFrom - layer.imageHeight / 2 : t;
                    layer.setPos(fl, ft);
                }
                layer.setMove(l, t, moveAccel, moveTime);
            } else {
                layer.setMove(l, t);
            }
            xposFrom = void;
            yposFrom = void;
            moveTime = void;
            reposition = false;
        }
    }
    
    function onStore(f) {
        global.KAGEnvLayer.onStore(f);
        global.KAGEnvLevelLayer.onStore(f);
        f.name = name;
    }

    function onRestore(f) {
        name = name;
        global.KAGEnvLevelLayer.onRestore(f);
        global.KAGEnvLayer.onRestore(f);
    }

    var layerCommands = %[
    front : this.setFront incontextof this,
    back : this.setBack incontextof this,
    level : this.setLevel incontextof this,
        ];
}

class VoiceTrack extends WaveSoundBuffer {

    var owner;
    
    function VoiceTrack(owner) {
        this.owner = owner;
        super.WaveSoundBuffer(owner);
    }

    function play() {
        owner.onStartVoice();
        super.play(...);
    }

    var prevstatus = "unload"; // ÕXe[^X

    function onStatusChanged() {
        super.onStatusChanged(...);
        var ps = prevstatus;
        var cs = status;
        prevstatus = cs;
        if(ps == "play" && cs == "stop") {
            owner.onStopVoice();
        }
    }
}

/**
 * LN^vOC
 */
class KAGEnvCharacter extends KAGEnvLevelLayer, KAGEnvImage {

    // kag ̎Q
    property kag {
        getter() {
            return env.kag;
        }
    }

    // tF[hw̃ftHg
    property fadeValue {
        getter() {
            if (init !== void && init.fadeValue !== void) {
                return init.fadeValue;
            } else {
                if (env.envinfo !== void && env.envinfo.charFadeValue !== void) {
                    return env.envinfo.charFadeValue;
                } else {
                    return env.fadeValue;
                }
            }
        }
    }

    /// O
    var name;
    /// 
    var initName;

    /// 
    var init;
    var poses;

    // 摜t@Cڎw
    var image;
    // ʃItZbg␳
    var yoffset;
    
    /// |[Y
    var _pose;
    property pose {
        getter() {
            if (_pose !== void) {
                return _pose;
            }
            if (init.defaultPose !== void) {
                return init.defaultPose;
            }
            return "ʏ";
        }
        setter(v) {
            _pose = v;
        }
    };

    /// 
    var dress;
    /// \
    var face;

    var facePoseMap;
    
    /// {CX
    var voice;
    var strVoice;
    var incVoice;   // true Ȃ當w莞JEg
    var noincVoice; // true ȂJEgȂ
    
    // x[X摜
    var baseImageName;
    // x[X摜
    var baseImage;
    // 摜
    var faceImage;

    // G[V
    var newEmotionFlag;
    var emotion;
    var emotionLayer;

    /**
     * RXgN^
     * @param env IuWFNg
     * @param layerId `ΏۃCԍ
     * @param name LN^
     * @param init LN^f[^
     */
    function KAGEnvCharacter(env, layerId, name, initName, init) {

        global.KAGEnvImage.KAGEnvImage(env);
        global.KAGEnvLevelLayer.KAGEnvLevelLayer(layerId);
        
        //dm("LN^o^:" + name + " layerId:" + layerId); 

        this.name     = name;
        this.initName = initName;
        this.init     = init;
        if (init) {
            poses = init.poses; //showKeys("poses", poses);
            
            // \|[Y@\
            if (init.facePose) {
                // \|[Yɑ΂}bv쐬
                facePoseMap = %[];
                foreach(poses, function(name, value, dict, facePoseMap) {
                    var faces = [];
                    faces.assign(value.faces);
                    for (var i=0; i<faces.count; i+= 2) {
                        facePoseMap[faces[i]] = name;
                    }
                }, facePoseMap);
            }

        }
    }
    
    function finalize() {
        if (baseImage !== void) {
            invalidate baseImage;
        }
        if (faceImage !== void) {
            invalidate faceImage;
        }
        if (soundBuffer !== void) {
            invalidate soundBuffer;
        }
        if (emotionLayer !== void) {
            invalidate emotionLayer;
        }
        // ԕύXs
        global.KAGEnvLevelLayer.finalize();
        global.KAGEnvImage.finalize();
    }

    /**
     * Z[u
     */
    function onStore(f) {
        global.KAGEnvImage.onStore(f);
        global.KAGEnvLevelLayer.onStore(f);
        f.name = name;
        f.initName = initName;
        f.image = image;
        f.yoffset = yoffset;
        f.pose = pose;
        f.dress = dress;
        f.face = face;
        f.voice = voice;
        f.strVoice = strVoice;
    }

    /**
     * [h
     */
    function onRestore(f) {
        image = f.image;
        yoffset = f.yoffset;
        pose  = f.pose;
        dress = f.dress;
        face  = f.face;
        voice = f.voice;
        strVoice = f.strVoice;
        global.KAGEnvLevelLayer.onRestore(f);
        global.KAGEnvImage.onRestore(f);
    }

    // \`揈s
    var redrawFace;

    /**
     * ډ摜w
     */
    function setImage(imageName, elm) {
        if (imageName != image || disp == CLEAR) {
            image = imageName;
            yoffset = elm.yoffset;
            if (disp == CLEAR) {
                disp = init.noimage ? FACE : BOTH;
                reposition = true;
            }
            redraw = true;
            
            // gWVw
            if (isShowBU()) {
                if (!setTrans2(init.poseTrans)) {
                    if (!setTrans2(init.charTrans)) {
                        if (!setTrans2(env.envinfo.poseTrans)) {
                            setTrans2(env.envinfo.charTrans);
                        }
                    }
                }
            }
        }
    }
    
    /**
     * |[Y̐ݒ
     */
    function setPose(poseName, elm) {
        var info = poses[poseName];
        if (info !== void) {
            if (poseName != pose || disp == CLEAR) {
                pose = poseName;
                yoffset = info.yoffset;
                if (disp == CLEAR) {
                    disp = init.noPose ? FACE : BOTH;
                    reposition = true;
                }
                redraw = true;
                
                // gWVw
                if (isShowBU()) {
                    if (!setTrans2(info.trans)) {
                        if (!setTrans2(init.poseTrans)) {
                            if (!setTrans2(init.charTrans)) {
                                if (!setTrans2(env.envinfo.poseTrans)) {
                                    setTrans2(env.envinfo.charTrans);
                                }
                            }
                        }
                    }
                }
                
                // \\擾
                if (isShowFace() && (elm.faceon || env.showFaceMode) && !elm.faceoff) {
                    redrawFace = true;
                }
            }
            // 
            if (dress !== void && (info.dresses == void || info.dresses[dress] == void)) {
                dress = void;
            }
            // \
            if (face !== void && (info.faces == void || info.faces[face] == void)) {
                face = void;
            }
        }

        // C[Wj
        image = void;
        // ypos ̓|[Yݒ肵Ƃ0ɖ߂
        ypos = 0;
        // G[VNA
        setEmotion();

    }

    /**
     * ̐ݒ
     */
    function setDress(dressName, elm) {
        if (dressName != dress || disp == CLEAR) {
            dress = dressName;
            if (disp == CLEAR) {
                disp = init.noPose ? FACE : BOTH;
                reposition = true;
            }
            redraw = true;
            // gWVw
            if (isShowBU()) {
                if (!setTrans2(init.dressTrans)) {
                    if (!setTrans2(init.charTrans)) {
                        if (!setTrans2(env.envinfo.dressTrans)) {
                            setTrans2(env.envinfo.charTrans);
                        }
                    }
                }
            }
            // \\擾
            if (isShowFace() && (elm.faceon || env.showFaceMode) && !elm.faceoff) {
                redrawFace = true;
            }
        }
        image = void;
    }
    /**
     * \̐ݒ
      */
    function setFace(faceName, elm) {
        if (faceName != face || disp == CLEAR) {
            face = faceName;
            if (disp == CLEAR) {
                disp = init.noPose ? FACE : BOTH;
                reposition = true;
            }
            redraw = true;
            // gWVw
            if (isShowBU()) {
                if (!setTrans2(init.faceTrans)) {
                    if (!setTrans2(init.charTrans)) {
                        if (!setTrans2(env.envinfo.faceTrans)) {
                            setTrans2(env.envinfo.charTrans);
                        }
                    }
                }
            }

            // \\擾
            if (isShowFace() && (elm.faceon || env.showFaceMode) && !elm.faceoff) {
                redrawFace = true;
            }
        }
        image = void;
    }

    /**
     * ꏊ\pgWVݒ
     */
    function setPositionTrans(info, force=false) {
        dm("ꏊgWVw");
        if (force || isShowBU()) {
            if (!setTrans2(info.trans)) {
                setTrans2(env.envinfo.positionTrans);
            }
        }
    }
    
    /**
     * \ʒu̐ݒ
     */
    function setPosition(cmd, elm) {

        var posName = getTo(cmd);
        var info;
        if (env.positions === void || (info = env.positions[posName]) === void) {
            return;
        }
        
        switch (info.type) {
        case global.KAGEnvironment.XPOSITION:
            if (disp == CLEAR) {
                disp = init.noPose ? FACE : BOTH;
            }
            moveTime = isSkip() ? 0 : elm.time;
            moveAccel = (elm.accel === void) ? 0 : +elm.accel;
            var posFrom = getFrom(cmd);
            var fromInfo;
            if (posFrom !== void && (fromInfo = env.positions[posFrom]) !== void) {
                xpos       = info.xpos;
                xposFrom   = fromInfo.xpos;
                reposition = true;
            } else {
                if (xpos === void && moveTime !== void) {
                    moveTime = 0;
                }
                xpos = info.xpos;
                reposition = true;
                if (moveTime === void) {
                    setPositionTrans(info);
                }
            }
            break;

        case global.KAGEnvironment.YPOSITION:
            if (disp == CLEAR) {
                disp = init.noPose ? FACE : BOTH;
            }
            moveTime = isSkip() ? 0 : elm.time;
            moveAccel = (elm.accel === void) ? 0 : +elm.accel;
            var posFrom = getFrom(cmd);
            var fromInfo;
            if (posFrom !== void && (fromInfo = env.positions[posFrom]) !== void) {
                ypos       = info.ypos;
                yposFrom   = fromInfo.ypos;
                reposition = true;
            } else {
                if (ypos === void && moveTime !== void) {
                    moveTime = 0;
                }
                ypos = info.ypos;
                reposition = true;
                if (moveTime === void) {
                    setPositionTrans(info);
                }
            }
            break;

        case global.KAGEnvironment.DISPPOSITION:
            disp = info.disp;
            redraw = true;
            reposition = true;
            setPositionTrans(info, true);
            break;

        case global.KAGEnvironment.LEVEL:
            //dm("x:" + info.level);
            level = info.level;
            redraw = true;
            reposition = true;
            if (disp > CLEAR) {
                redraw = true;
            }
            setPositionTrans(info);
            break;
        }
    }

    /**
     * G[V̐ݒ
     */
    function setEmotion(name, elm) {
        if (name !== void) {
            if (env.emotions !== void) {
                var info;
                if ((info = env.emotions[name]) !== void) {
                    emotion = %[];
                    (Dictionary.assign incontextof emotion)(info, false);
                    newEmotionFlag = true;
                    emotion.time = elm.time if elm.time !== void;
                    return true;
                }
            }
            return false;
        } else {
            // G[V
            newEmotionFlag = false;
            if (emotion !== void) {
                invalidate emotion;
                emotion = void;
            }
            if (emotionLayer !== void) {
                invalidate emotionLayer;
                emotionLayer = void;
            }
        }
    }
    
    var charCommands = %[
    image   : this.setImage incontextof this,
    dress   : this.setDress incontextof this,
    face    : function(cmd,elm) {
        if (facePoseMap !== void) {
            var p;
            if ((p = facePoseMap[cmd]) !== void) {
                setPose(p,elm);
                setFace(cmd,elm);
            }
        } else {
            setFace(cmd,elm);
        }
    }incontextof this,
    pos     : this.setPosition incontextof this,
    emotion : this.setEmotion incontextof this,
    xpos    : this.setXPos incontextof this,
    ypos    : this.setYPos incontextof this,
    front   : this.setFront incontextof this,
    back    : this.setBack incontextof this,
    level   : this.setLevel incontextof this,
    voice   : this.setVoice incontextof this,
    nextvoice : this.setNextVoice incontextof this,
    clearvoice : this.clearVoice incontextof this,
    playvoice : this.playVoice2 incontextof this,
    waitvoice : this.waitVoice incontextof this,
    facewin : function(param) { disp = FACE; } incontextof this,
    faceon : null,
    faceoff : null,
        ];

    /**
     * |[YwD揈
     */
    function doPoseCommand(cmd, param, elm) {

        // |[YR}h
        if (cmd == "pose") {
            setPose(param, elm);
            return true;
        }

        // |[Y}bv݂ꍇ
        if (facePoseMap !== void) {
            var p;
            if ((p = facePoseMap[cmd]) !== void) {
                setPose(p,elm);
                setFace(cmd,elm);
                return true;
            }
        }
        
        // |[Yw
        if (poses !== void) {
            if (poses[cmd] !== void) {
                setPose(cmd,elm);
                return true;
            }
        }
        
        return false;
    }
    
    /**
     * R}h̎s
     * @param cmd R}h
     * @param param p[^
     * @param elm ̃R}h܂ޑSp[^
     * @return ssꂽꍇ true
     */
    function doCommand(cmd, param, elm) {

        if (global.KAGEnvImage.doCommand(cmd, param, elm)) {
            return true;
        }

        var func;
        if ((func = charCommands[cmd]) !== void) {
            if (func != null) {
                func(param, elm);
            }
            return true;
        }
        
        var info;
        var find = false;

        if (!find && poses !== void && pose !== void && image === void) {
            var poseInfo;
            if ((poseInfo = poses[pose]) !== void) {
                var dresses       = poseInfo.dresses;
                var faces         = poseInfo.faces;
                if (dresses !== void && dresses[cmd] !== void) {
                    //dm("ݒ");
                    find = true;
                    setDress(cmd,elm);
                } else if (faces !== void && faces[cmd] !== void) {
                    //dm("\ݒ");
                    find = true;
                    setFace(cmd,elm);
                }
            } else {
                dm("|[Y񂪂܂:" + pose + ":" + cmd);
            }
        }

        var posName = getTo(cmd);
        if (!find && env.positions !== void && env.positions[posName] !== void) {
            setPosition(cmd, elm);
            find = true;
        }            

        // ANV
        if (!find) {
            find = setAction(cmd, elm);
        }

        // G[V
        if (!find) {
            find = setEmotion(cmd, elm);
        }
        
        // XV
        if (!find) {
            find = _setTrans(cmd, elm);
        }
        
        return find;
    };

    /**
     * G̕`
     * @param layer `ΏۃC
     * @param levelName x
     * @param pose |[Yw
     * @oaram face `tO
     * @return  true
     */
    function _drawLayerPose(layer, levelName, pose) {

        var imageName;
        var poseInfo;
        if (poses !== void && (poseInfo = poses[pose]) !== void) {

            // `̏ꍇ msgImage / msgFaceImage D
            var imageName     = (levelName == env.faceLevelName && poseInfo.msgImage !== void)     ? poseInfo.msgImage : poseInfo.image;
            var faceImageName = (levelName == env.faceLevelName && poseInfo.msgFaceImage !== void) ? poseInfo.msgFaceImage : poseInfo.faceImage;
            var dresses       = poseInfo.dresses;
            var faces         = poseInfo.faces;

            imageName = imageName.replace(/LEVEL/, levelName);

            // w肪ꍇ̓ftHgQ
            var dressName;
            if (dress !== void) {
                dressName = dresses[dress];
            } 
            dressName = poseInfo.defaultDress if dressName === void;

            // \w肪ꍇ̓ftHgQ
            var faceName;
            if (face !== void) {
                faceName = faces[face];
            }
            faceName = poseInfo.defaultFace if faceName === void;

            //dm("dress:", dressName, "face:", faceName);
            
            if (faceImageName !== void) {
                
                // 番^G

                // x[X
                var imageFile = imageName.replace(/DRESS/, dressName);

                // x[X摜̃[h
                if (baseImageName != imageFile) {
                    baseImageName = imageFile;
                    // 摜x[X̃LbVp
                    if (baseImage === void) {
                        baseImage = new global.Layer(kag, kag.fore.base);
                        baseImage.name = "G摜LbV:" + name;
                    }
                    try {
                        baseImage.loadImages(imageFile);
                    } catch (e) {
                        dm("Gx[X摜̓ǂݍ݂Ɏs܂:" + imageFile);
                        if (dressName !== poseInfo.defaultDress) {
                            dm("ftHg̕p܂:" + poseInfo.defaultDress);
                            dressName = poseInfo.defaultDress;
                            imageFile = imageName.replace(/DRESS/, dressName);
                            baseImageName = imageFile;
                            try {
                                baseImage.loadImages(imageFile);
                            } catch (e) {
                                dm("Gx[X摜̓ǂݍ݂Ɏs܂:" + imageFile);
                                return false;
                            }
                        } else {
                            return false;
                        }
                    } 
                }
                
                // 摜CɊ蓖Ă
                layer.assignImages(baseImage);
                // XXX ƍČKv
                layer.type    = layer._initType    = baseImage.type;
                layer.opacity = layer._initOpacity = baseImage.opacity;

                // xp
                faceImageName = faceImageName.replace(/LEVEL/, levelName);
                
                //@\w
                if (faceName !== void) {
                    imageFile = faceImageName.replace(/DRESS/, dressName);
                    imageFile = imageFile.replace(/FACE/, faceName);
                    var imageInfo;
                    if (faceImage === void) {
                        faceImage = new global.Layer(kag, kag.fore.base);
                        faceImage.name = "G摜p:" + name;
                    }
                    try {
                        imageInfo = faceImage.loadImages(imageFile);
                    } catch (e) {
                        var succeeded = false;
                        // ̃ftHgƂ݂̓G[ł͂Ȃ
                        if (dressName != poseInfo.defaultDress) {
                            dressName = poseInfo.defaultDress;
                            imageFile = faceImageName.replace(/DRESS/, dressName);
                            imageFile = imageFile.replace(/FACE/, faceName);
                            try {
                                imageInfo = faceImage.loadImages(imageFile);
                                succeeded = true;
                            } catch (e) {
                            }
                        }
                        if (!succeeded) {
                            dm("\摜̓ǂݍ݂Ɏs܂:" + imageFile);
                            if (faceName != poseInfo.defaultFace) {
                                dm("ftHg̕\p܂:" + poseInfo.defaultFace);
                                faceName = poseInfo.defaultFace;
                                imageFile = faceImageName.replace(/DRESS/, dressName);
                                imageFile = imageFile.replace(/FACE/, faceName);
                                try {
                                    imageInfo = faceImage.loadImages(imageFile);
                                } catch (e) {
                                    dm("\摜̓ǂݍ݂Ɏs܂:" + imageFile);
                                }
                            }
                        }
                    }
                    if (imageInfo && imageInfo.offs_x !== void) {
                        layer.operateRect(imageInfo.offs_x, imageInfo.offs_y,
                                          faceImage, 0, 0, faceImage.imageWidth, faceImage.imageHeight);
                    } else {
                        layer.operateRect(0,0,faceImage,0,0,faceImage.imageWidth, faceImage.imageHeight);
                    }
                }
                return true;
                
            } else {
                // 獇^G
                // ŏ㏑
                if (dressName !== void) {
                    imageName = imageName.replace(/DRESS/, dressName);
                }
                // \ŏ㏑
                if (faceName !== void) {
                    imageName = imageName.replace(/FACE/, faceName);
                }
                //dm("imageName", imageName);
                try {
                    if (layer instanceof "AnimationLayer") {
                        layer.loadImages(%[ "storage" => imageName]);
                    } else {
                        layer.loadImages(imageName);
                    }
                    return true;
                } catch (e) {
                    dm("ERROR:摜t@C̓ǂݍ݂Ɏs܂:" + imageName);
                }
            }
        } else {
            dm("G񂪂܂:" + pose);
        }
        return false;
    }

    /**
     * ݂̗G̕`
     * @param layer `ΏۃC
     * @param levelName x
     */
    function _drawLayer(layer, levelName) {

        if (image !== void) {
            var imageName = image.replace(/LEVEL/, levelName);
            try {
                if (layer instanceof "AnimationLayer") {
                    layer.loadImages(%[ "storage" => image]);
                } else {
                    layer.loadImages(image);
                }
            } catch (e) {
                dm("ERROR:摜t@C̓ǂݍ݂Ɏs܂:" + image);
                return false;
            }
        } else {
            if (!_drawLayerPose(layer, levelName, pose)) {
                dm("G[hł܂ł:" + levelName + ":" + pose);
                if (pose !== init.defaultPose) {
                    dm("ftHg̃|[Yp܂:" + init.defaultPose);
                    if (!_drawLayerPose(layer, levelName, init.defaultPose)) {
                        dm("G[hł܂ł:" + levelName + ":" + init.defaultPose);
                        return false;
                    }
                } else {
                    return false;
                }
            }
        }

        // TCY␳
        layer.setSizeToImageSize();
        
        // F␳
        var timeInfo;
        if ((timeInfo = env.currentTime) !== void) {
            // C
            if (timeInfo.charLightColor !== void) {
                layer.holdAlpha = true;
                layer.fillOperateRect(0,0,
                                      layer.width,layer.height,
                                      timeInfo.charLightColor,
                                      timeInfo.charLightType);
            }
            // x␳
            if (timeInfo.charBrightness !== void) {
                layer.light(timeInfo.charBrightness,
                            timeInfo.charContrast);
            }
        }
        
        if (grayscale) {
            layer.doGrayScale();
        }
        if (rgamma != void || ggamma != void || bgamma != void) {
            layer.adjustGamma(rgamma == void ? 1.0 : rgamma, 0, 255,
                              ggamma == void ? 1.0 : ggamma, 0, 255,
                              bgamma == void ? 1.0 : bgamma, 0, 255);
        }
    }

    /**
     * ݂̗G̕`
     * @param layer `ΏۃC
     */
    function drawLayer(layer) {
        initLayer(layer);
        var levelName;
        var levelInfo = env.levels[level];
        if (levelInfo !== void) {
            levelName = levelInfo.name;
        }
        if (levelName === void) {
            levelName = level;
        }
        return _drawLayer(layer, levelName);
    }

    /**
     * \`悷
     */
    function drawFace(layer, faceLevelName) {
        //dm("\`:" + name + " face:" + face + " layer:" + layer.name + " level:" + faceLevelName);
        if (faceLevelName !== void && poses !== void) {
            _drawLayer(layer, faceLevelName);
            layer.visible = true;
        } else {
            layer.visible = false;
        }
    }

    /**
     * Czu(LN^p)F_{x␳
     * @param layer ΏۃC
     */
    function calcPosition(layer) {
        if (reposition) {
            //dm("ʒuw3");

            // ftHg
            if (xpos === void) {
                xpos = env.defaultXpos;
            }
            if (ypos === void) {
                ypos = env.defaultYpos;
            }

            var yoff = yoffset !== void ? +yoffset : init.yoffset !== void ? +init.yoffset : +env.yoffset;
            
            // xʍW␳BƂ肠KŉʒɌďkĂ
            var zoom;
            var levelYoffset = 0;
            var levelInfo = env.levels[level];
            if (levelInfo !== void) {
                zoom         = (int)levelInfo.zoom;
                levelYoffset = (int)levelInfo.yoffset;
            }
            if (zoom === void) {
                zoom = 100;
            }
            if (levelYoffset === void) {
                levelYoffset = 0;
            }
            
            var l = kag.scWidth  / 2 + ((int)xpos * zoom / 100) - layer.imageWidth / 2;
            var t = kag.scHeight / 2 + ((yoff - (int)ypos) * zoom / 100) - layer.imageHeight + levelYoffset;
            if (moveTime) {
                if (xposFrom !== void || yposFrom !== void) {
                    var fl = xposFrom !== void ? kag.scWidth  / 2 + ((int)xposFrom * zoom / 100) - layer.imageWidth / 2 : l;
                    var ft = yposFrom !== void ? kag.scHeight / 2 + ((yoff - (int)yposFrom) * zoom / 100) - layer.imageHeight + levelYoffset: t;
                    layer.setPos(fl, ft);
                } 
                layer.setMove(l, t, moveAccel, moveTime);
            } else {
                layer.setMove(l, t);
            }
            xposFrom = void;
            yposFrom = void;
            moveTime = void;
            reposition = false;
        }
    }
    
    /**
     * CԍXV
     * G[Vǉ
     */
    function updateLayer(layer) {
        global.KAGEnvImage.updateLayer(...);

        // \`
        if (redrawFace) {
            if (env.currentNameTarget != this) {
                env.drawName();
            }
            env.drawFacePage(layer.parent === kag.fore.base ? kag.fore : kag.back, this);
            env.currentNameTarget = this;

            redrawFace = false;
        }
        
        // LN^\ĂȂꍇ̓G[V͖
        if (!isShowBU()) {
            setEmotion();
        }

        // VKG[V
        if (newEmotionFlag) {
            // G[Vs

            if (emotion) {
                var emoX;
                var emoY;
                var emoRev;

                // \W
                emoX    = init.emoX   if init.emoX   !== void;
                emoY    = init.emoY   if init.emoY   !== void;
                emoRev  = init.emoRev if init.emoRev !== void;

                // |[Yʕ␳
                var info;
                if ((info = poses[pose]) !== void) {
                    emoX   = poseInfo.emoX   if info.emoX   !== void;
                    emoY   = poseInfo.emoY   if info.emoY   !== void;
                    emoRev = poseInfo.emoRev if info.emoRev !== void;
                }
                
                // VKG[VC
                emotionLayer = new global.ActionLayer(layer.window, layer.parent);
                
                if (emoRev && emotion.imageRev !== void) {
                    emoitonLayer.loadImages(emotion.imageRev);
                } else {
                    emotionLayer.loadImages(emotion.image);
                }
                emotionLayer.setPos(layer.left + layer.width/2 + emoX,
                                    layer.top  + layer.height  - emoY);
                emotionLayer.visible = true;
                emotion.beginAction(emotion.action);
            }
            
            newEmotionFlag = false;
        }
    }
    
    /**
     * KAG ^O
     * @param elm 
     */
    function tagfunc(elm) {
        //dm("LN^^ǑĂяo:" + name);
        ret = void;

        {
            var e = %[];
            (Dictionary.assign incontextof e)(elm); 
            var names = [];
            names.assign(e);
            // |[YwR}h͗D揈
            for (var i=0; i<names.count; i+= 2) {
                if (doPoseCommand(names[i], names[i+1], e)) {
                    delete e[names[i]];
                }
            }
            foreach(e, doCommand);
        }
        hideMessage();
        updateImage();
        return ret;
    }

    var reNumber = new RegExp("^[0-9][0-9]*$");

    // ZȂtO
    var noinc;
    
    /**
     * {CXt@C̎w
     */
    function setVoice(param, elm) {
        if (typeof param == "Integer") {
            if (elm.once) {
                strVoice = getVoice(param);
            } else {
                voice = param;
                strVoice = void;
            }
        } else if (typeof param == "String") {
            if (reNumber.test(param)) {
                if (elm.once) {
                    strVoice = getVoice((int)param);
                } else {
                    voice = (int)param;
                    strVoice = void;
                }
            } else {
                strVoice = param;
            }
        } else {
            voice = void;
            strVoice = void;
        }
        incVoice   = elm.incvoice;
        noincVoice = elm.noincvoice;
        //dm("{CXݒ:" + param + ":" + voice);
    }

    /**
     * {CXt@Cw{ĐGg
     */
    function setNextVoice(param) {
        env.entryNextVoice(this);
    }
    
    /**
     * {CXt@Cw̉
     */
    function clearVoice() {
        voice = void;
        strVoice = void;
    }
    
    /**
     * {CXt@C̎擾
     * @param voice p[^@l̏ꍇ͏Ȁꍇ͂̂܂ܕԂ
     */
    function getVoice(voice) {
        if (typeof voice == "Integer") {
            if (init.voiceFile === void) {
                return void;
            }
            var voiceBase = f.voiceBase !== void ? f.voiceBase : "";
            if (f.name != sf.defaultName || f.family != sf.defaultFamily) {
                // ftHgȊO̖Ȍꍇ
                var name = init.voiceFile.sprintf(voiceBase, voice, "N");
                if (Storages.isExistentStorage(name)) {
                    return name;
                }
            }
            // ʂ̖Ȍꍇ
            return init.voiceFile.sprintf(voiceBase, voice, "");
        } else if (typeof voice == "String") {
            return voice;
        }
        return void;
    }

    function getCurrentVoice() {
        return strVoice == "ignore" ? void : getVoice(strVoice !== void ? strVoice : voice);
    }

    var initSound;
    var soundBuffer;
    var voiceEndTime;

    function updateVoice() {
        initSound = true;
    }
    
    /**
     * {CXJn
     */
    function onStartVoice() {
        //dm("{CXJn{[Jn");
        if (kag.sflags.bgmdown && !env.kag.skipMode) {
            kag.bgm.voldown = true;
        }
    }

    /**
     * {CX~
     */
    function onStopVoice() {
        //dm("{CXJn{[䊮");
        voiceEndTime = void;
        if (kag.bgm.voldown) {
            kag.bgm.voldown = false;
        }
    }

    /**
     * {CX̍Đ
     */
    function playVoice(voicename=void) {
        voiceEndTime = void;
        var ret = void;
        if (voicename === void) {
            voicename = getCurrentVoice();
            if (strVoice === void || incVoice) {
                if (typeof voice == "Integer") {
                    if (!noincVoice) {
                        voice++;
                    }
                } else {
                    voice = void;
                }
            }
            incVoice   = void;
            noincVoice = void;
            strVoice   = void;
        }

        if (voicename !== void && kag.getVoiceOn(init.voiceName)) {
            if (!kag.skipMode && kag.voiceenable) {
                //dm("Đ:" + voicename);
                // Đs
                if (initSound) {
                    if (soundBuffer !== void) {
                        invalidate soundBuffer;
                        soundBuffer = void;
                    }
                    initSound = false;
                }
                if (soundBuffer === void) {
                    soundBuffer = new VoiceTrack(this);
                }
                // {[␳
                //dm("{CX{[" + kag.voicevolume);
                soundBuffer.volume2 = kag.getVoiceVolume(init.voiceName) * 1000;
                try {
                    // gq⊮
                    if (!Storages.isExistentStorage(voicename)) {
                        var test;
                        if(test = voicename + ".wav", Storages.isExistentStorage(test))
                            voicename = test;
                        else if(test = voicename + ".ogg", Storages.isExistentStorage(test))
                            voicename = test;
                    }
                    if (kag.voicespeed != 1.0 && typeof soundBuffer.filters != "undefined") {
                        soundBuffer.filters.clear();
                        soundBuffer.filters.add(new WaveSoundBuffer.PhaseVocoder());
                        soundBuffer.filters[0].window = 256;
                        soundBuffer.filters[0].time = 1.0 / kag.voicespeed;
                    }
                    soundBuffer.open(voicename);
                    soundBuffer.play();
                    ret = (int)(soundBuffer.totalTime / kag.voicespeed);
                } catch (e) {
                    dm("{CXĐɎs܂ t@C:" + voicename);
                }
            }
        }
        if (ret) {
            voiceEndTime = System.getTickCount() + ret;
        }
        return ret;
    }

    /**
     * {CX̊O̍Đ
     */
    function playVoice2(param) {
        //dm("O{CXĐ:" + param);
        if (typeof param == "String") {
            if (reNumber.test(param)) {
                param = (int)param;
            }
        } else {
            param = void;
        }
        playVoice(getVoice(param));
    }

    /**
     * {CX̒~
     */
    function stopVoice() {
        voiceEndTime = void;
        if (soundBuffer !== void) {
            soundBuffer.stop();
            if (typeof soundBuffer.filters != "undefined") {
                soundBuffer.filters.clear();
            }
        }
    }

    /**
     * {CX҂
     * @param true ̏ꍇXLbv\iftHgj
     * @param falsȅꍇXLbvs\
     */
    function waitVoice(param) {
        if (voiceEndTime !== void) {
            var waitTime = voiceEndTime - System.getTickCount();
            ret = kag.waitTime(waitTime, param == true && kag.clickSkipEnabled);
        }
    }
    

    /**
     * {CX̃{[̍Ē
     */
    function resetVoiceVolume() {
        if (soundBuffer !== void) {
            soundBuffer.volume2 = kag.getVoiceVolume(init.voiceName) * 1000;
        }
    }
};

/**
 * BGMIuWFNg
 */
class KAGEnvBgm {

    var env;

    /**
     * RXgN^
     */
    function KAGEnvBgm(env) {
        this.env = env;
    }

    /**
     * Đ
     * @param param ĐΏۃt@C
     */
    function play(param, elm) {
        if (param !== void) {
            var time = +elm.time;
            if (elm.noxchg) {
                if (time > 0)  {
                    kag.bgm.fadeIn(%[ storage:param, loop:elm.loop, time:time, start:elm.start]);
                } else {
                    kag.bgm.play(%[ storage:param, loop:elm.loop, paused:elm.paused, start:elm.start]);
                }
            } else {
                if (time > 0 || +elm.intime > 0) {
                    kag.bgm.exchange(%[ storage:param, loop:elm.loop, time:time, intime:elm.intime, outtime:elm.outtime, overlap:elm.overlap, start:elm.start]);
                } else {
                    kag.bgm.play(%[ storage:param, loop:elm.loop, paused:elm.paused, start:elm.start]);
                }
            }
            kag.clearBgmStop();
            kag.clearBgmLabel();
            // ĐǃtO
            kag.sflags["bgm_" + (param.toUpperCase())] = true;
        }
    }

    /**
     * ~
     * @param param tF[hAEg
     */
    function stop(param, elm) {
        if (+param > 0) {
            kag.bgm.fadeOut(%[ time: +param]);
        } else {
            kag.bgm.stop();
        }
    }

    /**
     * |[Y
     * @param param tF[hAEg
     */
    function pause(param, elm) {
        if (+param > 0) {
            kag.bgm.fadePause(%[ time: +param]);
        } else {
            kag.bgm.pause();
        }
    }

    /**
     * ĊJ
     */
    function resume(param, elm) {
        kag.bgm.resume();
    }

    /**
     * ʃtF[h
     * @param param tF[h
     */
    function fade(param, elm) {
        kag.bgm.fade(%[ time:elm.time, volume:param ]);
    }

    /**
     * I܂
     * @param param tF[h
     */
    function wait(param, elm) {
        var e = %[];
        (Dictionary.assign incontextof e)(elm, false);
        if (e.canskip === void) {
            e.canskip = true;
        }
        ret = kag.waitBGMStop(e);
    }

    /**
     * I܂
     * @param param tF[h
     */
    function waitFade(param, elm) {
        var e = %[];
        (Dictionary.assign incontextof e)(elm, false);
        if (e.canskip === void) {
            e.canskip = true;
        }
        ret = kag.waitBGMFade(e);
    }


    var bgmcommands = %[
    tagname : null, 
    play : play incontextof this,
    stop : stop incontextof this,
    pause : pause incontextof this,
    resume : resume incontextof this,
    fade : fade incontextof this,
    wait : wait incontextof this,
    waitfade : waitFade incontextof this,
    noxchg : null,
    loop : null,
    time : null,
    start : null,
    paused : null,
    intime : null,
    outtime : null,
    overlap : null,
    canskip : null,
        ];

    var doflag;
    
    /**
     * R}h̎s
     * @param cmd R}h
     * @param param p[^
     * @param elm ̃R}h܂ޑSp[^
     * @return ssꂽꍇ true
     */
    function doCommand(cmd, param, elm) {
        var func;
        if ((func = bgmcommands[cmd]) !== void) {
            if (func != null) {
                func(param, elm);
                doflag = true;
            }
            return true;
        }
        // ĐR}hƂ݂Ȃ
        play(cmd, elm);
        doflag = true;
        return true;
    }

    var ret;

    /**
     * KAG ^O
     * @param elm 
     */
    function tagfunc(elm) {
        //dm("BGM pt@NVĂяo!");
        ret = 0;
        doflag = false;
        foreach(elm, doCommand);
        // ȂꍇAA^O bgm łȂ΂Đ
        if (!doflag && elm.tagname != "bgm") {
            play(elm.tagname, elm);
        }
        return ret;
    }
    
};

/**
 * BGMIuWFNg
 */
class KAGEnvSE {

    var env;
    var id;
    var name;  // QƂĂt@C
    var count; // QƂꂽJEgl
    
    /**
     * RXgN^
     */
    function KAGEnvSE(env, id) {
        this.env = env;
        this.id = id;
    }

    /**
     * Đ
     * @param param ĐΏۃt@C
     */
    function play(param, elm) {
        if (param !== void) {
            name = param;
            var time = +elm.time;
            if (time > 0)  {
                kag.se[id].fadeIn(%[ storage:param, loop:elm.loop, time:time, start:elm.start]);
            } else {
                kag.se[id].play(%[ storage:param, loop:elm.loop, start:elm.start]);
            }
        }
    }

    /**
     * ~
     * @param param tF[hAEg
     */
    function stop(param, elm) {
        if (+param > 0) {
            kag.se[id].fadeOut(%[ time: +param]);
        } else {
            kag.se[id].stop();
        }
    }

    /**
     * ʃtF[h
     * @param param tF[h
     */
    function fade(param, elm) {
        kag.se[id].fade(%[ time:elm.time, volume:param ]);
    }

    /**
     * I҂
     */
    function wait(param, elm) {
        var e = %[];
        (Dictionary.assign incontextof e)(elm, false);
        e.buf = id;
        if (e.canskip === void) {
            e.canskip = true;
        }
        ret = kag.waitSEStop(e);
    }

    /**
     * tF[hI҂
     */
    function waitFade(param, elm) {
        var e = %[];
        (Dictionary.assign incontextof e)(elm, false);
        e.buf = id;
        if (e.canskip === void) {
            e.canskip = true;
        }
        ret = kag.waitSEFade(e);
    }

    var secommands = %[
    tagname : null, 
    play : play incontextof this,
    stop : stop incontextof this,
    fade : fade incontextof this,
    wait : wait incontextof this,
    waitfade : waitFade incontextof this,
    loop : null,
    time : null,
    start : null,
    canskip : null,
    buf : null
        ];

    var doflag;

    /**
     * R}h̎s
     * @param cmd R}h
     * @param param p[^
     * @param elm ̃R}h܂ޑSp[^
     * @return ssꂽꍇ true
     */
    function doCommand(cmd, param, elm) {
        var func;
        if ((func = secommands[cmd]) !== void) {
            if (func != null) {
                func(param, elm);
                doflag = true;
            }
            return true;
        }
        // ĐR}hƂ݂Ȃ
        play(cmd, elm);
        doflag = true;
        return true;
    }

    var ret;
    
    /**
     * KAG ^O
     * @param elm 
     */
    function tagfunc(elm) {
        // dm("SE pt@NVĂяo!");
        ret = 0;
        doflag = false;
        foreach(elm, doCommand);
        // ȂꍇAA^O se łȂ΂Đ
        if (!doflag && elm.tagname != "se") {
            play(elm.tagname, elm);
        }
        return ret;
    }
};


/**
 * IuWFNg
 */
class KAGEnvironment extends KAGEnvImage {

    /// KAG{̂̎Q
    var kag;

    // tF[hw̃ftHgl
    // envinit.tjs Œ`邩AVXẽftHgg
    property fadeValue {
        getter() {
            if (envinfo !== void && envinfo.fadeValue !== void) {
                return envinfo.fadeValue;
            } else {
                return 500;
            }
        }
    }
    
    /// 
    var envinfo;

    var times;        //< ԏ
    var stages;       //< 
    var events;       //< CxgG
    var positions;    //< zu
    var actions;      //< ANV
    var transitions;  //< gWV
    var defaultTime;  //< ftHg̎
    var yoffset;      //< LN^zuyoffset l
    var defaultXpos;  //< LN^zȕXʒu
    var defaultYpos;  //< LN^zȕYʒu
    var defaultLevel; //< LN^x̃ftHgl
    var levels;       //< LN^xʕ␳
    var faceLevelName;//< tFCXEChEp̕\
    var emotions;
    
    /// ̃CJEg
    var initLayerCount;

    /// ݂̃CJEg
    var layerCount;
    
    /// LN^ꗗ
    var characterNames;
    /// LN^ꗗ
    var characterInits;
    /// LN^
    var characters;
    /// C
    var layers;

    /// CxgC
    var event;

    // BGM n
    var bgm;

    // SE n
    var ses;
    
    //@ݎ
    property currentTime {
        getter() {
            if (times !== void && time !== void) {
                return times[time];
            }
        }
    }

    // bZ[WΏۂɂȂftHg̃IuWFNg
    // O\̂Ɛݒ肳
    // n߂͉̌
    var currentNameTarget;
    // R}hsɕ\s[h
    var showFaceMode;
    // \̃tF[hw
    var faceFadeTime;

    // SJ[
    var colorall;

    // 摜␮w

    property grayscale {
        getter() {
            return _grayscale;
        }
        setter(v) {
            _grayscale = v;
            if (colorall) {
                setColorAll(true);
            }
            redraw = true;
        }
    }

    property rgamma {
        getter() {
            return _rgamma;
        }
        setter(v) {
            _rgamma = v;
            if (colorall) {
                setColorAll(true);
            }
            redraw = true;
        }
    }

    property ggamma {
        getter() {
            return _ggamma;
        }
        setter(v) {
            _ggamma = v;
            if (colorall) {
                setColorAll(true);
            }
            redraw = true;
        }
    }
    
    property bgamma {
        getter() {
            return _bgamma;
        }
        setter(v) {
            _bgamma = v;
            if (colorall) {
                setColorAll(true);
            }
            redraw = true;
        }
    }

    function resetColor(param, elm) {
        _grayscale = void;
        _rgamma = void;
        _ggamma = void;
        _bgamma = void;
        if (colorall) {
            setColorAll(true);
        }
        redraw = true;
    }

    function setColorAll(param) {
        colorall = param;
        // ׂčĕ`揈
        event.setRedraw();
        foreach(characters, function(name, value, dict) {
            value.setRedraw();
        });
        foreach(layers, function(name, value, dict) {
            value.setRedraw();
        });
        redraw = true;
    }

    
    /**
     * RXgN^
     * @param kag KAG{
     */
    function KAGEnvironment(kag) {

        super.KAGEnvImage(this);
        
        this.kag = kag;
        characters = %[];
        characterInits = %[];
        layers = %[];
        event = new KAGEnvBaseLayer(env, "event");

        // BGM IuWFNg
        bgm = new KAGEnvBgm(env);
        // SE ێpBz
        ses = [];
        for (var i=0; i<kag.numSEBuffers; i++) {
            ses[i] = new KAGEnvSE(env, i);
        }
        
        // ŏ̎sɂ̎_ő݂Ă郌C̔ԍ܂ł͑Ώۂ͂悤ɂ
        initLayerCount = kag.numCharacterLayers;

        // WJ
        envinfo = loadEnvinfo();

        if (envinfo) {
            // fobO\ 
            times       = envinfo.times;       showKeys("times", times);
            stages      = envinfo.stages;      showKeys("stages", stages);
            events      = envinfo.events;      showKeys("events", events);
            positions   = envinfo.positions;   showKeys("positions", positions);
            actions     = envinfo.actions;     showKeys("actions", actions);
            emotions    = envinfo.emotions;    showKeys("emotions", emotions);
            transitions = envinfo.transitions; showKeys("transitions", transitions);
            defaultTime = envinfo.defaultTime;      dm("defaultTime:" + defaultTime);
            yoffset     = (int)envinfo.yoffset;     dm("yoffset:" + yoffset);
            defaultXpos = (int)envinfo.defaultXpos;
            defaultYpos = (int)envinfo.defaultYpos;
            defaultLevel = (int)envinfo.defaultLevel;
            levels       = envinfo.levels;
            faceLevelName = envinfo.faceLevelName;
            showFaceMode  = envinfo.showFaceMode;
            faceFadeTime  = envinfo.faceFadeTime;

        
            // LN^񏉊
            if (envinfo.characters !== void) {
                
                //dm("LN^񏉊");
                
                var chinit = [];
                chinit.assign(envinfo.characters);
                
                //dm("LN^" + chinit.count);
                
                for (var i=0; i<chinit.count; i+=2) {
                    var name = chinit[i];
                    var init = chinit[i+1];
                    characterInits[name] = init;
                }
                
            }
        } else {
            dm("񂪂܂");
        }
        
        // KAG ɎR}hƂēo^
        kag.tagHandlers["env"]        = this.tagfunc;
        kag.tagHandlers["allchar"]   = this.allchar;
        kag.tagHandlers["alllayer"]   = this.alllayer;

        kag.tagHandlers["begintrans"] = this.beginTrans;
        kag.tagHandlers["endtrans"]   = this.endTrans;
        kag.tagHandlers["newlay"]     = this.newLayer;
        kag.tagHandlers["newchar"]    = this.newCharacter;

        kag.tagHandlers["msgoff"]     = this.msgoff;
        kag.tagHandlers["msgon"]      = this.msgon;
        kag.tagHandlers["clear"]      = this.clear;
        
        kag.tagHandlers["dispname"]        = this.dispname;
        kag.tagHandlers["dispnameVoice"]   = this.dispnameVoice;
        kag.tagHandlers["quake"]           = this.quake;
        kag.tagHandlers["afterpage"]       = this.afterpage;
        kag.tagHandlers["afterline"]       = this.afterline;

        // nho^
        kag.unknownHandler         = this.unknown;
        kag.seStopHandler          = this.onSeStop;
        kag.stopActionHandler      = this.onStopAction;

        kag.updateVoice            = this.updateVoice;
        
        dm("");
    }

    /**
     * ̃[h
     */
    function loadEnvinfo() {
        try {
            var yamlFile = 'envinit.yaml';
            if (Storages.isExistentStorage(yamlFile)) {
                return YAML.parse([].load(yamlFile));
            }

            return Scripts.evalStorage("envinit.tjs");
        } catch (e) {
            throw new Exception("̃p[XɎs܂(ڍׂ̓R\[Q)");
        }
    }

    /**
     * Z[u
     */
    function onStore(f) {
        super.onStore(f);
        f.time = time;
        f.stage = stage;

        var chars = %[];
        foreach(characters, function(name, value, dict) {
            var fch = %[];
            value.onStore(fch);
            this[name] = fch;
        } incontextof chars);
        f.characters = chars;
        
        var lays = %[];
        foreach(layers, function(name, value, dict) {
            var fch = %[];
            value.onStore(fch);
            this[name] = fch;
        } incontextof lays);
        f.layers = lays;

        f.event = %[];
        event.onStore(f.event);

        f.colorall = colorall;
    }

    /**
     * [h
     */
    function onRestore(f) {
        init();
        time = f.time;
        stage = f.stage;
        if (f.characters) {
            foreach(f.characters, function(name, value, dict) {
                var ch = getCharacter(value.name, value.initName, value.layerId);
                if (ch != null) {
                    ch.onRestore(value);
                }
            } incontextof this);
        }
        if (f.layers) {
            foreach(f.layers, function(name, value, dict) {
                var l = getEnvLayer(value.name, true, value.layerId);
                if (l !== void) {
                    l.onRestore(value);
                }
            } incontextof this);
        }
        if (f.event) {
            event.onRestore(f.event);
        }
        super.onRestore(f);

        colorall = f.colorall;
        if (colorall) {
            setColorAll(colorall);
        }

        updateImage();
    }
    
    /**
     * t@CiCU
     */
    function finalize() {
        init();
        dm("I");
        if (kag.unknownHandler === this.unknown) {
            kag.tagHandlers = void;
        }
        if (kag.seStopHandler== this.onSeStop) {
            kag.seStopHandler          = void;
        }
        if (kag.stopActionHandler === this.onStopAction) {
            kag.stopActionHandler = void;
        }
        invalidate characters;
        invalidate layers;
        invalidate event;
        super.finalize();
    }

    // -----------------------------------------

    /// 
    var time;
    /// 
    var stage;

    // -----------------------------------------

    /**
     * ̏
     */
    function init() {

        //dm("");
        time = void;
        stage = void;
        transMode = void;

        colorall = false;

        initImage();
        event.initImage();

        // LN^̔j
        foreach(characters, function(name,value,dict) {
            invalidate value;
            delete dict[name];
        });
        // ꃌC̔j
        foreach(layers, function(name,value,dict) {
            invalidate value;
            delete dict[name];
        });
        layerCount = 0;
        kag.allocateCharacterLayers(initLayerCount + layerCount, false);

        // SE 
        for (var i=0;i<ses.count;i++) {
            ses[i].name  = void;
            ses[i].count = 0;
        }
        seCount = 0;

        // JgIuWFNg
        currentNameTarget = void;
        redraw = true;
        
        voiceCharacters.clear();
    }

    /**
     * CxgG̏
     */
    function hideEvent(param, elm) {
        if (event.disp != CLEAR) {
            event.disp = CLEAR;
            event.setFade2(param);
            redraw = true;
        }
    }

    /**
     * wiƃCxgG̏
     */
    function hideBase(param, elm) {
        if (event.disp != CLEAR) {
            event.disp = CLEAR;
            event.setFade2(param);
            disp = CLEAR;
            fadeTime = 0;
            redraw = true;
        } else if (disp != CLEAR) {
            disp = CLEAR;
            setFade2(param);
            redraw = true;
        }
    }
    
    /**
     * SLN^
     */
    function hideCharacters(param, elm) {
        // LN^C̏
        foreach(characters, function(name,value,dict,param) {
            if (value.disp != CLEAR) {
                value.disp = CLEAR;
                value.setFade2(param);
                redraw = true;
            }
        } incontextof this, param);
        currentNameTarget = void;
    }

    /**
     * SC
     */
    function hideLayers(param, elm) {
        // ꃌC̏
        foreach(layers, function(name,value,dict, param) {
            if (value.disp != CLEAR) {
                value.disp = global.KAGEnvImage.CLEAR;
                value.setFade2(param);
                redraw = true;
            }
        } incontextof this, param);
    }

    /**
     * Oivf
     */
    function hideFore(param, elm) {
        hideCharacters(param, elm);
        hideLayers(param, elm);
    }

    /**
     * Svf
     */
    function hideAll(param, elm) {
        hideBase(param, elm);
        hideCharacters(param, elm);
        hideLayers(param, elm);
    }
    
    /**
     * ݒ肷
     * @param stageName 䖼
     * @param elm R}ĥق̗vf
     */
    function setStage(stageName, elm) {
        if (stageName != stage || disp == CLEAR) {

            stage = stageName;
            disp = BOTH;

            // wiw莞ɍWw肪ȂΏꏊ
            if (elm.xpos === void) {
                xpos = void;
            }
            if (elm.ypos === void) {
                ypos = void;
            }
            reposition = true;

            // Xe[WύXtbN
            if (global.setStageHook !== void) {
                global.setStageHook(stageName, elm);
            }

            // gWVw
            if (!setTrans2(stages[stage].trans)) {
                if (!setTrans2(env.envinfo.stageTrans)) {
                    setTrans2(env.envinfo.envTrans);
                }
            }

        }
        // CxgG͏
        if (event.disp != CLEAR) {
            event.disp = CLEAR;
            redraw = true;
        }
    }

    /**
     * Ԃݒ肷
     * @param timeName Ԗ
     * @param elm R}ĥق̗vf
     */
    function setTime(timeName, elm) {
        if (timeName != time || disp == CLEAR) {
            time = timeName;
            disp = BOTH;

            // ԕύXtbN
            if (global.setTimeHook !== void) {
                global.setTimeHook(timeName, elm);
            }

            // ԕύX̓L̗Gĕ`̕Kv
            foreach(characters, function(name, value, dict) {
                value.setRedraw();
            });

            // gWVw
            if (!setTrans2(times[time].trans)) {
                if (!setTrans2(env.envinfo.timeTrans)) {
                    setTrans2(env.envinfo.envTrans);
                }
            }
        }
        // CxgG͏
        if (event.disp != CLEAR) {
            event.disp = CLEAR;
            redraw = true;
        }
    }

    // gWV[h
    var transMode;

    /**
     * S̃gWVJn
     */
    function beginTrans(elm) {
        kag.fore.base.stopTransition();
        kag.backupLayer(EMPTY, true);
        transMode = true;
        return 0;
    }

    /**
     * gWVwR}hT
     */
    function checkTrans(cmd, param, elm) {
        if (cmd == "tagname") {
            // ignore
        } else if (cmd == "trans") {
            setTrans(param, elm);
        } else if (cmd == "fade") {
            var fadeTime = +param;
            trans = %[ "method" => "crossfade",
                       "children" => true,
                       "time" => fadeTime > 1 ? fadeTime : fadeValue];
        } else {
            _setTrans(cmd, elm);
        }
    }

    /**
     * S̃gWVI
     */
    function endTrans(elm) {
        // ܂igWV true Əo^Ȃ̂)
        transMode = false;
        ret = void;
        foreach(elm, checkTrans);
        // w莞
        if (trans !== void && trans.method !== void) {
            hideMessage();
            beginTransition(trans);
        } else {
            // ʂ珑߂
            kag.backupLayer(EMPTY, false);
        }
        trans = void;
        return ret;
    }

    /**
     * VKC
     */
    function newLayer(elm) {
        var lay = getEnvLayer(elm.name, true);
        if (lay != null) {
            delete elm.tagname;
            delete elm.name;
            return lay.tagfunc(elm);
        }
        return 0;
    }

    /**
     * VKLN^
     */
    function newCharacter(elm) {
        // f[^͔p
        if (characters[elm.name] !== void) {
            invalidate characters[elm.name];
            delete characters[elm.name];
        }
        // VK
        var ch = getCharacter(elm.name, elm.initname);
        if (ch != null) {
            delete elm.tagname;
            delete elm.name;
            delete elm.initname;
            return ch.tagfunc(elm);
        }
        return 0;
    }        

    /**
     * bZ[W̃gWV݂ ON/OFF
     */
    function msgonoff(elm, v) {
        ret = void;
        if (!v) {
            kag.conductor.pendings.insert(0, %[ tagname : "er", all:true]);
        }
        if (!transMode && !isSkip() && elm.nofade === void) {
            foreach(elm, checkTrans);
            if (trans !== void && trans.method !== void) {
                kag.updateBeforeCh = 1;
                kag.fore.base.stopTransition();
                kag.backupLayer(EMPTY, true);
                kag.setCurrentMessageLayerVisibleFast(1, v);
                beginTransition(trans);
                return ret;
            } else {
                return kag.setCurrentMessageLayerVisible(v) ? -2 : 0;
            }
        }
        kag.setCurrentMessageLayerVisibleFast(transMode ? 1: 0, v);
        return ret;
    }

    function msgon(elm) { return msgonoff(elm, true); }
    function msgoff(elm) { return msgonoff(elm, false); }

    /**
     * ʂ̕\vf̑S
     */
    function clear(elm) {
        ret = void;
        kag.conductor.pendings.insert(0, %[ tagname : "er", all:true]);
        hideAll();
        if (!transMode && !isSkip()) {
            foreach(elm, checkTrans);
            if (trans !== void && trans.method !== void) {
                kag.updateBeforeCh = 1;
                kag.fore.base.stopTransition();
                kag.backupLayer(EMPTY, true);
                kag.setCurrentMessageLayerVisibleFast(1, false);
                drawAll(kag.back);
                beginTransition(trans);
                return ret;
            }
        }
        kag.setCurrentMessageLayerVisibleFast(transMode ? 1: 0, false);
        drawAll();
        return ret;
    }

    var envCommands = %[
    /**
     * Ŝ̏
     */
    init : this.init incontextof this,
    stage : this.setStage incontextof this,
    stime : this.setTime incontextof this,
    hidebase : this.hideBase incontextof this,
    hideevent : this.hideEvent incontextof this,
    hidecharacters : this.hideCharacters incontextof this,
    hidelayers : this.hideLayers incontextof this,
    hidefore : this.hideFore incontextof this,
    hideall : this.hideAll incontextof this,
    stopallvoice : this.stopAllVoice incontextof this,
    colorall : this.setColorAll incontextof this,
        ];
    
    /**
     * R}h̎s
     * @param cmd R}h
     * @param param p[^
     * @param elm ̃R}h܂ޑSp[^
     * @return ssꂽꍇ true
     */
    function doCommand(cmd, param, elm) {

        //dm("R}hs:" + cmd);
        
        if (super.doCommand(cmd, param, elm)) {
            return true;
        }
        
        var func;
        if ((func = envCommands[cmd]) !== void) {
            //dm("o^R}h:" + cmd);
            if (func != null) {
                func(param, elm);
            }                
            return true;
        }

        var find = false;

        // Ԃƕ
        var info;
        if (times !== void && (info = times[cmd]) !== void) {
            setTime(cmd, elm);
            find = true;
        } else if (stages !== void && (info = stages[cmd]) !== void) {
            setStage(cmd, elm);
            find = true;
        }

        // ANV
        if (!find) {
            find = setAction(cmd, elm);
        }

        // XV
        if (!find) {
            find = setTrans(cmd, elm);
        }

        return find;
    }

    /**
     * 摜̕`
     * @param layer `惌C
     */
    function drawStage(layer) {
        var image;
        if (stage !== void) {
            image = stages[stage].image;
            // ԏŏ㏑
            if (time === void) {
                dm("Ԃ̎w肪܂");
                time = defaultTime;
            }
            if (time !== void) {
                image = image.replace(/TIME/, times[time].prefix);
                // 摜̃[hƍW␳
                try {
                    layer.loadImages(%[ "storage" => image ]);
                    
                    if (reposition) {
                        if (xpos === void) {
                            xpos = (int)stages[stage].xoff;
                        }
                        if (ypos === void) {
                            ypos = (int)stages[stage].yoff;
                        }
                    }

                } catch(e) {
                    // 摜[hłȂꍇ͕␳őΉ
                    image = stages[stage].image;
                    image = image.replace(/TIME/, times[defaultTime].prefix);

                    try {
                        layer.loadImages(%[ "storage" => image ]);
                        
                        // F␳
                        var timeInfo;
                        if ((timeInfo = currentTime) !== void) {
                            // C
                            if (timeInfo.lightColor !== void) {
                                layer.holdAlpha = true;
                                layer.fillOperateRect(0,0,
                                                      layer.width,layer.height,
                                                      timeInfo.lightColor,
                                                      timeInfo.lightType);
                            }
                            // x␳
                            if (timeInfo.brightness !== void) {
                                layer.light(timeInfo.brightness,
                                            timeInfo.contrast);
                            }
                        }

                        if (reposition) {
                            if (xpos === void) {
                                xpos = (int)stages[stage].xoff;
                            }
                            if (ypos === void) {
                                ypos = (int)stages[stage].yoff;
                            }
                        }
                        
                    } catch (e) {
                        dm("wi摜[hł܂" + image);
                    }
                }

            } else {
                dm("Ԃ̃ftHgw肪݂Ă܂");
            }


        } else {
            layer.clearImage(true);
        }

        if (grayscale) {
            layer.doGrayScale();
        }
        if (rgamma != void || ggamma != void || bgamma != void) {
            layer.adjustGamma(rgamma == void ? 1.0 : rgamma, 0, 255,
                              ggamma == void ? 1.0 : ggamma, 0, 255,
                              bgamma == void ? 1.0 : bgamma, 0, 255);
        }
    }

    /**
     * C쐬
     * @param base
     */
    function getLayer(base) {
        if (base === void) {
            base = env.transMode ? kag.back : kag.fore;
        }
        return base.stage;
    }
    
    function drawAll(base) {

        var layer = getLayer(base);
        initLayer(layer);

        if (isShowBU()) {
            drawStage(layer);
        }
        
        // qvf̍ĕ`
        foreach(characters, function(name, value, dict, base) {
            value.updateImage(base);
        }, base);
        foreach(layers, function(name, value, dict, base) {
            value.updateImage(base);
        }, base);
        event.updateImage(base);

        // bZ[W
        if (currentNameTarget == void) {
            drawNamePage(base);
            if (faceLevelName !== void) {
                clearFacePage(base);
            }
        }
        
        updateLayer(layer);

        calcPosition(layer);
    }

    /**
     * Czu(wip)F_
     * @param layer ΏۃC
     */
    function calcPosition(layer) {
        if (reposition) { 
            //dm("ʒuw2");
            var l = kag.scWidth / 2 + (int)xpos - layer.imageWidth / 2;
            var t = kag.scHeight/ 2 + (int)ypos - layer.imageHeight / 2;
            if (moveTime !== void && moveTime > 0) {
                if (xposFrom !== void || yposFrom !== void) {
                    var fl = xposFrom !== void ? kag.scWidth  / 2 + (int)xposFrom - layer.imageWidth / 2 : l;
                    var ft = yposFrom !== void ? kag.scHeight / 2 + (int)yposFrom - layer.imageHeight / 2 : t;
                    layer.setPos(fl, ft);
                }
                layer.setMove(l, t, moveAccel, moveTime);
            } else {
                layer.setMove(l, t);
            }
            xposFrom = void;
            yposFrom = void;
            moveTime = void;
            reposition = false;
        }
    }

    /**
     * ĕ`揈
     */
    function updateImage() {

        if (trans !== void && trans.charoff) {
            hideCharacters(void);
        }
        
        kag.updateBeforeCh = 1;

        // `XVKvȏꍇ
        if (redraw) {
            
            if (trans !== void) {

                fadeTime = void;

                if (trans.method !== void) {
                    kag.fore.base.stopTransition();
                    
                    // XV𑖂点ꍇ
                    if (trans.time === void) {
                        trans.time = 1000;
                    }
                    trans.children = true;
                    
                    // SCobNAbv
                    kag.backupLayer(EMPTY, true);
                    
                    // Xe[W̕`
                    drawAll(kag.back);
                    
                    // gWVs
                    beginTransition(trans);
                    
                } else {
                    drawAll();
                }

            } else {

                // tF[h
                // ɑ΂閽߂̏ꍇ͏ɃgWVg

                var layer = getLayer();
                if (fadeTime !== void && fadeTime > 0  && isShowBU() && layer.visible) {
                    
                    kag.fore.base.stopTransition();
                    var trans = %[ "method" => "crossfade",
                                   "children" => true,
                                   "time" => fadeTime > 1 ? fadeTime : fadeValue];
                    fadeTime = void;
                    
                    // SC𗠂ɃobNAbv
                    kag.backupLayer(EMPTY, true);
                    
                    // CΏ
                    drawAll(kag.back);
                    
                    // gWVs
                    beginTransition(trans);

                } else {
                    drawAll();
                }
            }
            redraw = false;
        } else {

            // qvf̍ĕ`
            foreach(characters, function(name, value, dict) {
                value.updateImage();
            });
            foreach(layers, function(name, value, dict, base) {
                value.updateImage();
            });
            event.updateImage();
            
            var layer = getLayer();
            updateLayer(layer);
            calcPosition(layer);
        }
        trans = void;
    }

    /**
     * KAG ^O
     * @param elm 
     */
    function tagfunc(elm) {
        //dm("^O΂ꂽ");
        ret = void;
        foreach(elm, doCommand);
        hideMessage();
        updateImage();

        // JgIuWFNg̉ XXX ł̂H
        return ret;
    }

    /**
     * SLɃR}hs
     * @param elm 
     */
    function allchar(elm) {
        ret = void;
        var names = [];
        names.assign(characters);
        for (var i=0; i<names.count; i+= 2) {
            ret = names[i+1].tagfunc(elm);
        }
        return ret;
    }

    /**
     * SCɃR}hs
     * @param elm 
     */
    function alllayer(elm) {
        ret = void;
        var names = [];
        names.assign(layers);
        for (var i=0; i<names.count; i+= 2) {
            ret = names[i+1].tagfunc(elm);
        }
        return ret;
    }

    /**
     * VKɃCID 擾
     * @param layerId w肳ꂽCID
     */
    function getLayerId(layerId) {
        if (layerId !== void) {
            if (layerId >= layerCount) {
                layerCount = layerId + 1;
            }
        } else {
            layerId = layerCount++;
        }
        kag.allocateCharacterLayers(env.initLayerCount + layerCount, false);
        return layerId;
    }
    
    /**
     * w肳ꂽÕLN^Ԃ
     * @param name O
     * @param initName 
     * @param layerId CID
     */
    function getCharacter(name, initName, layerId) {
        var ch = characters[name];
        if (ch === void) {
            if (initName === void) {
                initName = name;
            }
            var init;
            if ((init = characterInits[initName]) !== void) {
                layerId = getLayerId(layerId);
                ch = new KAGEnvCharacter(this, layerId, name, initName, init);
                characters[name] = ch;
            }
        }
        return ch;
    }

    /**
     * w肳ꂽÕCԂ
     * @param name O
     * @param create [h
     */
    function getEnvLayer(name, create=false, layerId) {
        var lay = layers[name];
        if (lay === void && create) {
            layerId = getLayerId(layerId);
            lay = new KAGEnvSimpleLayer(this, layerId, name);
            layers[name] = lay;
        }
        return lay;
    }

    /**
     * SL̃{CX~
     */
    function stopAllVoice() {
        foreach(characters, function(name, value, dict) {
            value.stopVoice();
        });
    }

    /**
     * SL̃{CX~
     */
    function resetAllVoiceVolume() {
        foreach(characters, function(name, value, dict) {
            value.resetVoiceVolume();
        });
    }
    
    /*
     * w肵LŎw肵{CXt@CĐ
     */
    function playVoice(name, voicename) {
        var ch = getCharacter(name);
        if (ch !== void && voicename !== void) {
            return ch.playVoice(voicename);
        }
    }

    function quake(elm) {
        // ĥƂ
        if (!isSkip()) {
            kag.doQuake(elm);
        }
        return 0;
    }
    
    function getMessageLayer(base) {
        if (base === void) {
            base = transMode ? kag.back : kag.fore;
        }
        return base.messages[kag.currentNum];
    }

    function getFaceLayer(base) {
        return getMessageLayer(base).faceLayer;
    }
    
    /**
     * \\
     */
    function loadFacePage(base, name) {
        var faceLayer = getFaceLayer(base);
        if (faceLayer !== void) {
            try {
                faceLayer.loadImages(name);
            } catch (e) {
                dm("\摜̃[hɎs܂:" + name);
            }
            faceLayer.visible = true;
        }
    }

    /**
     * \
     */
    function clearFacePage(base) {
        if (envinfo.clearFace !== void) {
            loadFacePage(base, envinfo.clearFace);
        } else {
            var faceLayer = getFaceLayer(base);
			if (faceLayer !== void) {
	            faceLayer.visible = false;
			}
        }
    }
    
    /**
     * \
     */
    function clearFace() {
        if (!transMode) {
            clearFacePage(kag.fore);
        }
        clearFacePage(kag.back);
    }

    // w肳ꂽLN^̕\\\Ȃ\
    function drawFacePage(base, ch) {
        if (faceLevelName !== void) {
            if (ch !== void) {
                var layer = getFaceLayer(base);
				if (layer !== void) {
	                if (ch.isShowFace()) {
    	                ch.drawFace(layer, faceLevelName);
        	        } else {
            	        layer.visible = false;
                	}
				}
            } else {
                clearFacePage(base);
            }
        }
    }

    /**
     * O̕\iy[Ww肠)
     */
    function drawNamePage(base, name="") {
        var msg = getMessageLayer(base);
        msg.processName(name);
    }

    /**
     * O̕\
     */
    function drawName(name = "") {
        if (!transMode) {
            drawNamePage(kag.fore, name);
        }
        drawNamePage(kag.back, name);
    }

    var voiceCharacters = [];

    function getVoicePlayingScript(ch) {
        var voice;
        if (ch !== void && (voice = ch.getCurrentVoice()) !== void) {
            return "global.world_object.env.playVoice(\"" + ch.name + "\",\"" + voice + "\");";
        } else {
            return "";
        }
    }
    
    /**
     * 񓯎ɖ炷{CX̒ǉ
     */
    function entryNextVoice(ch) {
        voiceCharacters.add(ch);
    }
    
    function getNextVoiceScript() {
        var ret = "";
        for (var i=voiceCharacters.count-1;i>=0;i--) {
            ret += getVoicePlayingScript(voiceCharacters[i]);
        }
        return ret;
    }

    /**
     * Ȃ炷{CX邩
     */
    function checkNextVoice() {
        for (var i=voiceCharacters.count-1;i>=0;i--) {
            var voice = voiceCharacters[i].getCurrentVoice();
            if (voice !== void) {
                return true;
            }
        }
        return false;
    }

    /**
     * {CX炷
     */
    function playNextVoice() {
        var ret = void;
        for (var i=voiceCharacters.count-1;i>=0;i--) {
            var ch = voiceCharacters[i]; 
            var voice = ch.getCurrentVoice();
            if (voice !== void) {
                var r = ch.playVoice();
                if (ret === void || (r !== void && r > ret)) {
                    ret = r;
                }
            }
        }
        voiceCharacters.clear();
        return ret;
    }
    
    /**
     * O\nh
     */
    function dispname(elm) {

        ret = void;
        
        if (kag.sflags.voicecut) {
            stopAllVoice();
        }

        // \\
        
        //dm("O\nh");
        if (elm === void || elm.name === void || elm.name == "") {
            
            // Lw肪ꍇ
            drawName();
            
            // \
            if (faceLevelName !== void && currentNameTarget !== void && currentNameTarget.isShowFace() && !transMode && !isSkip() && faceFadeTime > 0) {
                // tF[XtF[hŏꍇ
                kag.backupLayer(EMPTY, true);
                clearFacePage(kag.back);
                beginTransition(%[ method: "crossfade", time: faceFadeTime]);
                
            } else {
                if (faceLevelName !== void) {
                    clearFace();
                }
            }

            currentNameTarget = void;
            dispnameVoice(elm);
            
        } else {

            var name = elm.name;
            var disp = elm.disp;
            var ch = getCharacter(name);

            // O\
            var dispName;
            if (disp !== void && disp != "") {
                dispName = disp;
            } else {
                if (ch !== void && ch.init.nameAlias !== void) {
                    dispName = Scripts.eval(ch.init.nameAlias);
                    if (dispName === void) {
                        dispName = name;
                    }
                } else {
                    dispName = name;
                }
            }
            elm.dispName = dispName;
            
            // ԂȂ\Ԃɂ
            if (faceLevelName !== void && ch !== void && ch.disp == CLEAR && ch.poses) {
                ch.disp = FACE;
            }
            
            // \ύX
            if (faceLevelName !== void && currentNameTarget != ch &&
                ((currentNameTarget !== void && currentNameTarget.isShowFace()) || (ch !== void && ch.isShowFace())) &&
                !transMode && !isSkip() && faceFadeTime > 0) {
                
                // tF[hŕ\ꍇ

                // XXX O
                drawName();
                
                currentNameTarget = ch;
                
                kag.backupLayer(EMPTY, true);
                if (ch !== void && ch.isShowFace()) {
                    drawFacePage(kag.back, ch);
                } else {
                    var img;
                    if (envinfo.nameFaces !== void && (img = envinfo.nameFaces[envinfo.dispNameFace ? dispName : name]) !== void) {
                        loadFacePage(kag.back, img);
                    } else {
                        clearFacePage(kag.back);
                    }
                }

                // {CXĐ̐摗
                var e = %[];
                (Dictionary.assign incontextof e)(elm, false);
                e.tagname = "dispnameVoice";
                kag.conductor.pendings.insert(0, e);

                beginTransition(%[ method: "crossfade", time: faceFadeTime]);

            } else {

                // uԕ\ꍇ
                // Ԃ񂱂̃WbNKvȂH
                
                currentNameTarget = ch;
                
                if (ch !== void && ch.isShowFace()) {
                    if (!transMode) {
                        drawFacePage(kag.fore, ch);
                    }
                    drawFacePage(kag.back, ch);
                } else {
                    var img;
                    if (envinfo.nameFaces !== void && (img = envinfo.nameFaces[envinfo.dispNameFace ? dispName : name]) !== void) {
                        if (!transMode) {
                            loadFacePage(kag.fore, img);
                        }
                        loadFacePage(kag.back, img);
                    } else {
                        clearFace();
                    }
                }
                dispnameVoice(elm);
            }
        }
        return ret;
    }

    /**
     * O\{{CXĐ
     * {CX̏Ԃɉ҂ԕ␳s
     */
    function dispnameVoice(elm) {

        // -------  O\iuԁj

        if (elm === void || elm.name === void || elm.name == "") {

            // łɖO\ς
            
        } else {
            var name     = elm.name;
            var dispName = elm.dispName;
            if (dispName === void) {
                dispName = name;
            }

            var ch = getCharacter(name);

            // {CX̓o^
            var nextVoice;
            if (kag.historyWriteEnabled && (nextVoice = getNextVoiceScript() + getVoicePlayingScript(ch)) != "") {
                kag.historyLayer.setNewAction("global.world_object.env.stopAllVoice();" + nextVoice);
            }

            // OH
            if (typeof global.dispNameFilter !== 'undefined') {
                dispName = global.dispNameFilter(dispName);
            }
            // qXgp
            if (kag.historyWriteEnabled) {
                if (typeof kag.historyLayer.storeName !== 'undefined') {
                    kag.historyLayer.storeName(dispName);
                } else {
                    kag.historyLayer.store(dispName + " ");
                }
            }

            drawName(dispName);
        }

        // -------  {CXĐ
        
        // {CXĐ
        var ret;
        if (currentNameTarget !== void) {
            // {CXĐꍇ
            if (currentNameTarget.getCurrentVoice() !== void || checkNextVoice()) {
                // ق̃{CX
                env.stopAllVoice();
                // Đ{CX̍Đ
                ret = currentNameTarget.playVoice();
                var r = playNextVoice();
                if (ret === void || (r !== void && r > ret)) {
                    ret = r;
                }
            }
        } else {
            // {CXĐꍇ
            if (checkNextVoice()) {
                // ق̃{CX
                env.stopAllVoice();
                // Đ{CX̍Đ
                ret = playNextVoice();
            }
        }
        kag.addAutoWait(ret);
        return 0;
    }

    /**
     * s҂IɌĂяo鏈
     */
    function afterline(elm) {
        if (kag.sflags.voicecutpage) {
            stopAllVoice();
        }
        if (kag.historyWriteEnabled) {
            kag.historyLayer.clearAction();
        }
		return 0;
    }

    /**
     * y[WɌĂяo鏈
     */
    function afterpage(elm) {
        if (kag.sflags.voicecutpage) {
            stopAllVoice();
        }
        if (kag.historyWriteEnabled) {
            kag.historyLayer.clearAction();
            kag.historyLayer.reline();
        }
        return 0;
    }
    
    var seCount = 0;
    /**
     * SE pIuWFNg̎擾
     * @param id SEԍw
     * ԌÂSE킩悤ɃJEgĂ
     */
    function getSe(id) {
        ses[id].count = seCount++;
        return ses[id];
    }

    /**
     * SE ~̏
     * ~Ԃɂ
     */
    function onSeStop(id) {
        if (id < ses.count) {
            ses[id].name = void;
        }
    }

    /**
     * SE  ID 肷
     * @param buf obt@IDw
     */
    function getSeId(buf) {
        // ڃobt@w肳Ăꍇ͂Ԃ
        if (buf !== void && +buf < ses.count) {
            return +buf;
        }
        // gĂȂ̂
        var max = seCount;
        var old = void;
        for (var i=0; i<ses.count; i++) {
            if (ses[i].name == void) {
                return i;
            }
            if (ses[i].count < max) {
                max = ses[i].count;
                old = i;
            }
        }
        // ԌÂ̂Ԃ
        return old;
    }

    /**
     * SE  ID 肷
     * @param name SE ̖O
     */
    function getSeIdFromName(name) {
        for (var i=0; i<ses.count; i++) {
            if (ses[i].name == name) {
                return i;
            }
        }
        // ݂Ȃ̂łĂԍԂ
        return getSeId();
    }
    
    /**
     * KAG snh
     */
    function unknown(tagName, elm) {

        //dm("sR}hnh:" + tagName);

        // ̃R}hH
        if (doCommand(tagName, true, elm)) {
            // cR}hƂĎs
            ret = void;
            elm.tagname = "env";
            foreach(elm, doCommand);
            hideMessage();
            updateImage();
            return ret;
        }

        // Cxgp
        if (tagName == "event" || tagName == "ev") {
            return event.tagfunc(elm);
        } else if (tagName.substring(0,2) == "ev" ||
                   (events !== void && events[tagName] !== void)) {
            elm[tagName] = true;
            return event.tagfunc(elm);
        }

        // BGM p
        if (tagName == "bgm") {
            return bgm.tagfunc(elm);
        } else if (tagName.substring(0,3) == "bgm") {
            return bgm.tagfunc(elm);
        }

        // SE p
        if (tagName == "se") {
            return getSe(getSeId(elm.buf)).tagfunc(elm);
        } else if (tagName.substring(0,2) == "se") {
            var se = getSe(getSeIdFromName(tagName));
            return se.tagfunc(elm);
        }
        
        // YLN^݂邩H
        var ch = getCharacter(tagName);
        if (ch !== void) {
            return ch.tagfunc(elm);
        }

        // YC݂邩H
        var lay = getEnvLayer(tagName);
        if (lay !== void) {
            return lay.tagfunc(elm);
        }
        
        // Jg̃R}hƂĎsĂ݂
        if (currentNameTarget !== void) {
            elm[tagName] = true;
            return currentNameTarget.tagfunc(elm);
        }
    }

    /**
     * ANV~
     */
    function onStopAction() {
        stopAction();
        event.stopAction();
        foreach(characters, function(name, value, dict) {
            value.stopAction();
        });
        foreach(layers, function(name, value, dict) {
            value.stopAction();
        });
        updateImage();
    }

    /**
     * {CXXV
     */
    function updateVoice() {
        foreach(characters, function(name, value, dict) {
            value.updateVoice();
        });
    }
    
};

KAGEnvironment.XPOSITION    = 1;
KAGEnvironment.LEVEL        = 2;
KAGEnvironment.DISPPOSITION = 3;
KAGEnvironment.YPOSITION    = 4;

KAGEnvImage.BOTH      = 1;
KAGEnvImage.BU        = 2;
KAGEnvImage.CLEAR     = 3;
KAGEnvImage.FACE      = 4;
KAGEnvImage.INVISIBLE = 5;

/**
 * KAG p[hgvOC
 */
class KAGWorldPlugin extends KAGPlugin
{
    var env;
    function KAGWorldPlugin(kag) {
        super.KAGPlugin();
        env = new KAGEnvironment(kag);
    }

    function finalize() {
        if (env) {
            invalidate env;
        }
    }

    function onStore(f, elm)
    {
        var dic = f.env = %[];
        env.onStore(dic);
    }

    function onRestore(f, clear, elm)
    {
        if (f.env !== void) {
            env.onRestore(f.env);
        }
    }
};

kag.addPlugin(global.world_object = new KAGWorldPlugin(kag));

dm("[hݒ芮");

@endscript
@endif

@return
